<?php

namespace WoocommercePplVendor\Jane\Component\JsonSchema;

use WoocommercePplVendor\Jane\Component\JsonSchema\Console\Command\DumpConfigCommand;
use WoocommercePplVendor\Jane\Component\JsonSchema\Console\Command\GenerateCommand;
use WoocommercePplVendor\Jane\Component\JsonSchema\Console\Loader\ConfigLoader;
use WoocommercePplVendor\Jane\Component\JsonSchema\Console\Loader\SchemaLoader;
use WoocommercePplVendor\Symfony\Component\Console\Application as BaseApplication;
class Application extends BaseApplication
{
    public const VERSION = '6.x-dev';
    /**
     * Constructor.
     */
    public function __construct()
    {
        parent::__construct('Jane', self::VERSION);
        $this->boot();
    }
    protected function boot() : void
    {
        $configLoader = new ConfigLoader();
        $this->add(new GenerateCommand($configLoader, new SchemaLoader()));
        $this->add(new DumpConfigCommand($configLoader));
    }
}
