<?php

namespace WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\Any;

use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Guess\ClassGuess;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Guess\Property;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\ObjectCheckTrait;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\ValidatorGuess;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\ValidatorInterface;
use WoocommercePplVendor\Jane\Component\JsonSchema\JsonSchema\Model\JsonSchema;
use WoocommercePplVendor\Symfony\Component\Validator\Constraints\EqualTo;
class ConstValidator implements ValidatorInterface
{
    use ObjectCheckTrait;
    public function supports($object) : bool
    {
        return $this->checkObject($object) && ((\is_array($object->getType()) ? \in_array('string', $object->getType()) : 'string' === $object->getType()) || null === $object->getType()) && (\method_exists($object, 'getConst') && null !== $object->getConst());
    }
    /**
     * @param JsonSchema          $object
     * @param ClassGuess|Property $guess
     */
    public function guess($object, string $name, $guess) : void
    {
        $guess->addValidatorGuess(new ValidatorGuess(EqualTo::class, ['value' => $object->getConst(), 'message' => 'This value should be equal to "{{ compared_value }}".']));
    }
}
