<?php

namespace WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\Any;

use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Guess\ClassGuess;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Guess\Property;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\ObjectCheckTrait;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\ValidatorGuess;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\ValidatorInterface;
use WoocommercePplVendor\Jane\Component\JsonSchema\JsonSchema\Model\JsonSchema;
use WoocommercePplVendor\Symfony\Component\Validator\Constraints\Choice;
class EnumValidator implements ValidatorInterface
{
    use ObjectCheckTrait;
    public function supports($object) : bool
    {
        return $this->checkObject($object) && ((\is_array($object->getType()) ? \in_array('string', $object->getType()) : 'string' === $object->getType()) || null === $object->getType()) && null !== $object->getEnum();
    }
    /**
     * @param JsonSchema          $object
     * @param ClassGuess|Property $guess
     */
    public function guess($object, string $name, $guess) : void
    {
        $guess->addValidatorGuess(new ValidatorGuess(Choice::class, ['choices' => $object->getEnum(), 'message' => '"{{ value }}" is not part of the set of possible choices for this field: "{{ choices }}".']));
    }
}
