<?php

namespace WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\Format;

use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Guess\ClassGuess;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Guess\Property;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\ObjectCheckTrait;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\ValidatorGuess;
use WoocommercePplVendor\Jane\Component\JsonSchema\Guesser\Validator\ValidatorInterface;
use WoocommercePplVendor\Jane\Component\JsonSchema\JsonSchema\Model\JsonSchema;
use WoocommercePplVendor\Symfony\Component\Validator\Constraints\Hostname;
class HostnameValidator implements ValidatorInterface
{
    use ObjectCheckTrait;
    public function supports($object) : bool
    {
        if (!\class_exists(Hostname::class)) {
            return \false;
        }
        return $this->checkObject($object) && ((\is_array($object->getType()) ? \in_array('string', $object->getType()) : 'string' === $object->getType()) || null === $object->getType()) && 'hostname' === $object->getFormat();
    }
    /**
     * @param JsonSchema          $object
     * @param ClassGuess|Property $guess
     */
    public function guess($object, string $name, $guess) : void
    {
        $guess->addValidatorGuess(new ValidatorGuess(Hostname::class));
    }
}
