<?php

namespace WoocommercePplVendor\Jane\Component\OpenApi3\Generator\Endpoint;

use WoocommercePplVendor\Jane\Component\JsonSchema\Generator\Context\Context;
use WoocommercePplVendor\Jane\Component\JsonSchemaRuntime\Reference;
use WoocommercePplVendor\Jane\Component\OpenApi3\Generator\RequestBodyGenerator;
use WoocommercePplVendor\Jane\Component\OpenApi3\Guesser\GuessClass;
use WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Model\RequestBody;
use WoocommercePplVendor\Jane\Component\OpenApiCommon\Guesser\Guess\OperationGuess;
use WoocommercePplVendor\PhpParser\Node\Expr;
use WoocommercePplVendor\PhpParser\Node\Name;
use WoocommercePplVendor\PhpParser\Node\Param;
use WoocommercePplVendor\PhpParser\Node\Stmt;
use WoocommercePplVendor\Symfony\Component\Serializer\SerializerInterface;
trait GetGetBodyTrait
{
    public function getGetBody(OperationGuess $operation, Context $context, GuessClass $guessClass, RequestBodyGenerator $requestBodyGenerator) : Stmt\ClassMethod
    {
        $opRef = $operation->getReference() . '/requestBody';
        $requestBody = $operation->getOperation()->getRequestBody();
        if ($requestBody instanceof Reference) {
            [$_, $requestBody] = $guessClass->resolve($requestBody, RequestBody::class);
        }
        return new Stmt\ClassMethod('getBody', ['type' => Stmt\Class_::MODIFIER_PUBLIC, 'params' => [new Param(new Expr\Variable('serializer'), null, new Name\FullyQualified(SerializerInterface::class)), new Param(new Expr\Variable('streamFactory'), new Expr\ConstFetch(new Name('null')))], 'returnType' => new Name('array'), 'stmts' => $requestBodyGenerator->getSerializeStatements($requestBody, $opRef, $context)]);
    }
}
