<?php

namespace WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Normalizer;

use WoocommercePplVendor\Jane\Component\JsonSchemaRuntime\Reference;
use WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Runtime\Normalizer\CheckArray;
use WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Runtime\Normalizer\ValidatorTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Exception\InvalidArgumentException;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerAwareInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerAwareTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerAwareInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerAwareTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerInterface;
class HTTPSecuritySchemeNormalizer implements DenormalizerInterface, NormalizerInterface, DenormalizerAwareInterface, NormalizerAwareInterface
{
    use DenormalizerAwareTrait;
    use NormalizerAwareTrait;
    use CheckArray;
    use ValidatorTrait;
    public function supportsDenormalization($data, $type, $format = null, $context = []) : bool
    {
        return $type === 'Jane\\Component\\OpenApi3\\JsonSchema\\Model\\HTTPSecurityScheme';
    }
    public function supportsNormalization($data, $format = null, $context = []) : bool
    {
        return $data instanceof \WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Model\HTTPSecurityScheme;
    }
    /**
     * @return mixed
     */
    public function denormalize($data, $class, $format = null, array $context = array())
    {
        if (isset($data['$ref'])) {
            return new Reference($data['$ref'], $context['document-origin']);
        }
        if (isset($data['$recursiveRef'])) {
            return new Reference($data['$recursiveRef'], $context['document-origin']);
        }
        $object = new \WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Model\HTTPSecurityScheme();
        if (null === $data || \false === \is_array($data)) {
            return $object;
        }
        if (\array_key_exists('scheme', $data) && $data['scheme'] !== null) {
            $object->setScheme($data['scheme']);
            unset($data['scheme']);
        } elseif (\array_key_exists('scheme', $data) && $data['scheme'] === null) {
            $object->setScheme(null);
        }
        if (\array_key_exists('bearerFormat', $data) && $data['bearerFormat'] !== null) {
            $object->setBearerFormat($data['bearerFormat']);
            unset($data['bearerFormat']);
        } elseif (\array_key_exists('bearerFormat', $data) && $data['bearerFormat'] === null) {
            $object->setBearerFormat(null);
        }
        if (\array_key_exists('description', $data) && $data['description'] !== null) {
            $object->setDescription($data['description']);
            unset($data['description']);
        } elseif (\array_key_exists('description', $data) && $data['description'] === null) {
            $object->setDescription(null);
        }
        if (\array_key_exists('type', $data) && $data['type'] !== null) {
            $object->setType($data['type']);
            unset($data['type']);
        } elseif (\array_key_exists('type', $data) && $data['type'] === null) {
            $object->setType(null);
        }
        foreach ($data as $key => $value) {
            if (\preg_match('/^x-/', (string) $key)) {
                $object[$key] = $value;
            }
        }
        return $object;
    }
    /**
     * @return array|string|int|float|bool|\ArrayObject|null
     */
    public function normalize($object, $format = null, array $context = array())
    {
        $data = array();
        $data['scheme'] = $object->getScheme();
        if (null !== $object->getBearerFormat()) {
            $data['bearerFormat'] = $object->getBearerFormat();
        }
        if (null !== $object->getDescription()) {
            $data['description'] = $object->getDescription();
        }
        $data['type'] = $object->getType();
        foreach ($object as $key => $value) {
            if (\preg_match('/^x-/', (string) $key)) {
                $data[$key] = $value;
            }
        }
        return $data;
    }
}
