<?php

namespace WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Normalizer;

use WoocommercePplVendor\Jane\Component\JsonSchemaRuntime\Reference;
use WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Runtime\Normalizer\CheckArray;
use WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Runtime\Normalizer\ValidatorTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Exception\InvalidArgumentException;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerAwareInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerAwareTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerAwareInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerAwareTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerInterface;
class HTTPSecuritySchemeSubNormalizer implements DenormalizerInterface, NormalizerInterface, DenormalizerAwareInterface, NormalizerAwareInterface
{
    use DenormalizerAwareTrait;
    use NormalizerAwareTrait;
    use CheckArray;
    use ValidatorTrait;
    public function supportsDenormalization($data, $type, $format = null, $context = []) : bool
    {
        return $type === 'Jane\\Component\\OpenApi3\\JsonSchema\\Model\\HTTPSecuritySchemeSub';
    }
    public function supportsNormalization($data, $format = null, $context = []) : bool
    {
        return $data instanceof \WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Model\HTTPSecuritySchemeSub;
    }
    /**
     * @return mixed
     */
    public function denormalize($data, $class, $format = null, array $context = array())
    {
        if (isset($data['$ref'])) {
            return new Reference($data['$ref'], $context['document-origin']);
        }
        if (isset($data['$recursiveRef'])) {
            return new Reference($data['$recursiveRef'], $context['document-origin']);
        }
        $object = new \WoocommercePplVendor\Jane\Component\OpenApi3\JsonSchema\Model\HTTPSecuritySchemeSub();
        if (null === $data || \false === \is_array($data)) {
            return $object;
        }
        if (\array_key_exists('scheme', $data) && $data['scheme'] !== null) {
            $object->setScheme($data['scheme']);
        } elseif (\array_key_exists('scheme', $data) && $data['scheme'] === null) {
            $object->setScheme(null);
        }
        return $object;
    }
    /**
     * @return array|string|int|float|bool|\ArrayObject|null
     */
    public function normalize($object, $format = null, array $context = array())
    {
        $data = array();
        $data['scheme'] = $object->getScheme();
        return $data;
    }
}
