<?php

namespace WoocommercePplVendor\Http\Discovery\Strategy;

use WoocommercePplVendor\Psr\Http\Message\RequestFactoryInterface;
use WoocommercePplVendor\Psr\Http\Message\ResponseFactoryInterface;
use WoocommercePplVendor\Psr\Http\Message\ServerRequestFactoryInterface;
use WoocommercePplVendor\Psr\Http\Message\StreamFactoryInterface;
use WoocommercePplVendor\Psr\Http\Message\UploadedFileFactoryInterface;
use WoocommercePplVendor\Psr\Http\Message\UriFactoryInterface;
/**
 * @internal
 *
 * @author Tobias Nyholm <tobias.nyholm@gmail.com>
 *
 * Don't miss updating src/Composer/Plugin.php when adding a new supported class.
 */
final class CommonPsr17ClassesStrategy implements DiscoveryStrategy
{
    /**
     * @var array
     */
    private static $classes = [RequestFactoryInterface::class => ['WoocommercePplVendor\\Phalcon\\Http\\Message\\RequestFactory', 'WoocommercePplVendor\\Nyholm\\Psr7\\Factory\\Psr17Factory', 'WoocommercePplVendor\\GuzzleHttp\\Psr7\\HttpFactory', 'WoocommercePplVendor\\Http\\Factory\\Diactoros\\RequestFactory', 'WoocommercePplVendor\\Http\\Factory\\Guzzle\\RequestFactory', 'WoocommercePplVendor\\Http\\Factory\\Slim\\RequestFactory', 'WoocommercePplVendor\\Laminas\\Diactoros\\RequestFactory', 'WoocommercePplVendor\\Slim\\Psr7\\Factory\\RequestFactory', 'WoocommercePplVendor\\HttpSoft\\Message\\RequestFactory'], ResponseFactoryInterface::class => ['WoocommercePplVendor\\Phalcon\\Http\\Message\\ResponseFactory', 'WoocommercePplVendor\\Nyholm\\Psr7\\Factory\\Psr17Factory', 'WoocommercePplVendor\\GuzzleHttp\\Psr7\\HttpFactory', 'WoocommercePplVendor\\Http\\Factory\\Diactoros\\ResponseFactory', 'WoocommercePplVendor\\Http\\Factory\\Guzzle\\ResponseFactory', 'WoocommercePplVendor\\Http\\Factory\\Slim\\ResponseFactory', 'WoocommercePplVendor\\Laminas\\Diactoros\\ResponseFactory', 'WoocommercePplVendor\\Slim\\Psr7\\Factory\\ResponseFactory', 'WoocommercePplVendor\\HttpSoft\\Message\\ResponseFactory'], ServerRequestFactoryInterface::class => ['WoocommercePplVendor\\Phalcon\\Http\\Message\\ServerRequestFactory', 'WoocommercePplVendor\\Nyholm\\Psr7\\Factory\\Psr17Factory', 'WoocommercePplVendor\\GuzzleHttp\\Psr7\\HttpFactory', 'WoocommercePplVendor\\Http\\Factory\\Diactoros\\ServerRequestFactory', 'WoocommercePplVendor\\Http\\Factory\\Guzzle\\ServerRequestFactory', 'WoocommercePplVendor\\Http\\Factory\\Slim\\ServerRequestFactory', 'WoocommercePplVendor\\Laminas\\Diactoros\\ServerRequestFactory', 'WoocommercePplVendor\\Slim\\Psr7\\Factory\\ServerRequestFactory', 'WoocommercePplVendor\\HttpSoft\\Message\\ServerRequestFactory'], StreamFactoryInterface::class => ['WoocommercePplVendor\\Phalcon\\Http\\Message\\StreamFactory', 'WoocommercePplVendor\\Nyholm\\Psr7\\Factory\\Psr17Factory', 'WoocommercePplVendor\\GuzzleHttp\\Psr7\\HttpFactory', 'WoocommercePplVendor\\Http\\Factory\\Diactoros\\StreamFactory', 'WoocommercePplVendor\\Http\\Factory\\Guzzle\\StreamFactory', 'WoocommercePplVendor\\Http\\Factory\\Slim\\StreamFactory', 'WoocommercePplVendor\\Laminas\\Diactoros\\StreamFactory', 'WoocommercePplVendor\\Slim\\Psr7\\Factory\\StreamFactory', 'WoocommercePplVendor\\HttpSoft\\Message\\StreamFactory'], UploadedFileFactoryInterface::class => ['WoocommercePplVendor\\Phalcon\\Http\\Message\\UploadedFileFactory', 'WoocommercePplVendor\\Nyholm\\Psr7\\Factory\\Psr17Factory', 'WoocommercePplVendor\\GuzzleHttp\\Psr7\\HttpFactory', 'WoocommercePplVendor\\Http\\Factory\\Diactoros\\UploadedFileFactory', 'WoocommercePplVendor\\Http\\Factory\\Guzzle\\UploadedFileFactory', 'WoocommercePplVendor\\Http\\Factory\\Slim\\UploadedFileFactory', 'WoocommercePplVendor\\Laminas\\Diactoros\\UploadedFileFactory', 'WoocommercePplVendor\\Slim\\Psr7\\Factory\\UploadedFileFactory', 'WoocommercePplVendor\\HttpSoft\\Message\\UploadedFileFactory'], UriFactoryInterface::class => ['WoocommercePplVendor\\Phalcon\\Http\\Message\\UriFactory', 'WoocommercePplVendor\\Nyholm\\Psr7\\Factory\\Psr17Factory', 'WoocommercePplVendor\\GuzzleHttp\\Psr7\\HttpFactory', 'WoocommercePplVendor\\Http\\Factory\\Diactoros\\UriFactory', 'WoocommercePplVendor\\Http\\Factory\\Guzzle\\UriFactory', 'WoocommercePplVendor\\Http\\Factory\\Slim\\UriFactory', 'WoocommercePplVendor\\Laminas\\Diactoros\\UriFactory', 'WoocommercePplVendor\\Slim\\Psr7\\Factory\\UriFactory', 'WoocommercePplVendor\\HttpSoft\\Message\\UriFactory']];
    public static function getCandidates($type)
    {
        $candidates = [];
        if (isset(self::$classes[$type])) {
            foreach (self::$classes[$type] as $class) {
                $candidates[] = ['class' => $class, 'condition' => [$class]];
            }
        }
        return $candidates;
    }
}
