<?php

/*
Plugin Name: PPL CZ – plugin
Plugin URI: https://www.ppl.cz
Description: Jednoduché vytváření zásilek pro PPL CZ s.r.o. Integrace do košíku, editace adres objednávek, stavy zásilek (zjednodušené, kompletní) a jejich sledování. Základem pluginu je tisk etiket. Pro aktivaci pluginu, kontaktujte ithelp@ppl.cz
Author: PPL
Version: 1.0.1727253278
Author URI: https://www.ppl.cz
Requires Plugins: woocommerce
*/

defined("WPINC") or die();

require_once __DIR__ . '/build/vendor/autoload.php';
require_once __DIR__ . '/src/globals.php';

WoocommercePpl\Front\Components\ParcelShop\BlockData::register();
WoocommercePpl\Front\Components\ParcelShopSummary\BlockData::register();

WoocommercePpl\Front\Components\Map\Map::register();

WoocommercePpl\Admin\Page\OptionPage::register();
WoocommercePpl\Admin\RestController\SettingV1RestController::register();
WoocommercePpl\Admin\RestController\ShipmentV1RestController::register();
WoocommercePpl\Admin\RestController\SettingV1RestController::register();
WoocommercePpl\Admin\RestController\CodelistV1RestController::register();
WoocommercePpl\Admin\RestController\CollectionV1Controller::register();
WoocommercePpl\Admin\RestController\ShipmentBatchV1Controller::register();
WoocommercePpl\Admin\Cron\ShipmentPhaseCron::register();
WoocommercePpl\Admin\Cron\RefreshAboutCron::register();

function woocommerce_ppl_init()
{

    if (!WC()->session) {
        WC()->initialize_session();
    }
    WoocommercePpl\Template\Template::register();

    WoocommercePpl\Front\Components\ParcelShopSummary\BlockOrderConfirmation::register();
    WoocommercePpl\ShipmentMethod::register();

   WoocommercePpl\Front\Components\ParcelShop\BlockOldView::register();

    WoocommercePpl\Admin\Product\Tab::register();
    WoocommercePpl\Front\Validator\ParcelShopValidator::register();


    WoocommercePpl\Front\Operation\ParcelShopOperation::register();
    WoocommercePpl\Admin\Order\ParcelShop::register();
    WoocommercePpl\Admin\Order\OrderFilter::register();
    WoocommercePpl\Admin\Order\OrderPanel::register();
    WoocommercePpl\Admin\Order\OrderTable::register();
    WoocommercePpl\Admin\Category\CategoryPanel::register();

    WoocommercePpl\Admin\FileDownload::register();

    WoocommercePpl\Data\CollectionDataStore::register();
    WoocommercePpl\Data\ShipmentDataStore::register();
    WoocommercePpl\Data\AddressDataStore::register();
    WoocommercePpl\Data\CodBankAccountDataStore::register();
    WoocommercePpl\Data\PackageDataStore::register();
    WoocommercePpl\Data\ParcelDataStore::register();

}

add_action("before_woocommerce_init", "woocommerce_ppl_init");
add_action("woocommerce_init", "woocommerce_ppl_tables");

register_activation_hook(__FILE__, "woocommerce_ppl_activate");
register_deactivation_hook(__FILE__, "woocommerce_ppl_deactivate");
