<?php
/**
 * AddressWhisperApi
 * PHP version 7.4
 *
 * @category Class
 * @package  PluginPpl\MyApi2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * CPL
 *
 * **Changelog**    * 2024-08-22 - SPRJ-13791 - validace PRTE / PRBC externích čísel - nelze použít najednou    - /shipment/batch    * 2024-07-01 - SPRJ-13838 - přidání    - /customer/address    * 2023-11-23 - SPRJ-12703 - CPL - /shipment - timestamp    - /shipment - Rozšíření výstupu o LastUpdateDate.    * 2023-07-13 - SPRJ-11888 - přidání    - /codelist/status - číselník statusů    * 2023-07-13 - SPRJ-11953 - přidání    - /order/cancel - storno objednávky
 *
 * The version of the OpenAPI document: v1
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace PluginPpl\MyApi2\Api;

use WoocommercePplVendor\GuzzleHttp\Client;
use WoocommercePplVendor\GuzzleHttp\ClientInterface;
use WoocommercePplVendor\GuzzleHttp\Exception\ConnectException;
use WoocommercePplVendor\GuzzleHttp\Exception\RequestException;
use WoocommercePplVendor\GuzzleHttp\Psr7\MultipartStream;
use WoocommercePplVendor\GuzzleHttp\Psr7\Request;
use WoocommercePplVendor\GuzzleHttp\RequestOptions;
use PluginPpl\MyApi2\ApiException;
use PluginPpl\MyApi2\Configuration;
use PluginPpl\MyApi2\HeaderSelector;
use PluginPpl\MyApi2\ObjectSerializerPpl;

/**
 * AddressWhisperApi Class Doc Comment
 *
 * @category Class
 * @package  PluginPpl\MyApi2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class AddressWhisperApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $hostIndex (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $hostIndex = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $hostIndex;
    }

    /**
     * Set the host index
     *
     * @param int $hostIndex Host index (required)
     */
    public function setHostIndex($hostIndex): void
    {
        $this->hostIndex = $hostIndex;
    }

    /**
     * Get the host index
     *
     * @return int Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation addressWhisperGet
     *
     * Našeptávač adres
     *
     * @param  string $street Street (optional)
     * @param  string $zip_code Zip code (optional)
     * @param  string $city City (optional)
     * @param  EpsApiMyApi2WebModelsAddressWhisperCalledFrom $called_from Whispering from street / zip code / city text box (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \PluginPpl\MyApi2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsAddressWhisperAddressWhispModel[]|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel
     */
    public function addressWhisperGet($street = null, $zip_code = null, $city = null, $called_from = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        list($response) = $this->addressWhisperGetWithHttpInfo($street, $zip_code, $city, $called_from, $accept_language, $x_correlation_id, $x_log_level);
        return $response;
    }

    /**
     * Operation addressWhisperGetWithHttpInfo
     *
     * Našeptávač adres
     *
     * @param  string $street Street (optional)
     * @param  string $zip_code Zip code (optional)
     * @param  string $city City (optional)
     * @param  EpsApiMyApi2WebModelsAddressWhisperCalledFrom $called_from Whispering from street / zip code / city text box (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \PluginPpl\MyApi2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsAddressWhisperAddressWhispModel[]|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel, HTTP status code, HTTP response headers (array of strings)
     */
    public function addressWhisperGetWithHttpInfo($street = null, $zip_code = null, $city = null, $called_from = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        $request = $this->addressWhisperGetRequest($street, $zip_code, $city, $called_from, $accept_language, $x_correlation_id, $x_log_level);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsAddressWhisperAddressWhispModel[]' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsAddressWhisperAddressWhispModel[]' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, '\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsAddressWhisperAddressWhispModel[]', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 405:
                    if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 503:
                    if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsAddressWhisperAddressWhispModel[]';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializerPpl::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsAddressWhisperAddressWhispModel[]',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 405:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 503:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation addressWhisperGetAsync
     *
     * Našeptávač adres
     *
     * @param  string $street Street (optional)
     * @param  string $zip_code Zip code (optional)
     * @param  string $city City (optional)
     * @param  EpsApiMyApi2WebModelsAddressWhisperCalledFrom $called_from Whispering from street / zip code / city text box (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Promise\PromiseInterface
     */
    public function addressWhisperGetAsync($street = null, $zip_code = null, $city = null, $called_from = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        return $this->addressWhisperGetAsyncWithHttpInfo($street, $zip_code, $city, $called_from, $accept_language, $x_correlation_id, $x_log_level)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation addressWhisperGetAsyncWithHttpInfo
     *
     * Našeptávač adres
     *
     * @param  string $street Street (optional)
     * @param  string $zip_code Zip code (optional)
     * @param  string $city City (optional)
     * @param  EpsApiMyApi2WebModelsAddressWhisperCalledFrom $called_from Whispering from street / zip code / city text box (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Promise\PromiseInterface
     */
    public function addressWhisperGetAsyncWithHttpInfo($street = null, $zip_code = null, $city = null, $called_from = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        $returnType = '\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsAddressWhisperAddressWhispModel[]';
        $request = $this->addressWhisperGetRequest($street, $zip_code, $city, $called_from, $accept_language, $x_correlation_id, $x_log_level);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'addressWhisperGet'
     *
     * @param  string $street Street (optional)
     * @param  string $zip_code Zip code (optional)
     * @param  string $city City (optional)
     * @param  EpsApiMyApi2WebModelsAddressWhisperCalledFrom $called_from Whispering from street / zip code / city text box (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Psr7\Request
     */
    public function addressWhisperGetRequest($street = null, $zip_code = null, $city = null, $called_from = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {

        $resourcePath = '/addressWhisper';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $street,
            'Street', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $zip_code,
            'ZipCode', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $city,
            'City', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $called_from,
            'CalledFrom', // param base name
            'EpsApiMyApi2WebModelsAddressWhisperCalledFrom', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);

        // header params
        if ($accept_language !== null) {
            $headerParams['Accept-Language'] = ObjectSerializerPpl::toHeaderValue($accept_language);
        }
        // header params
        if ($x_correlation_id !== null) {
            $headerParams['X-Correlation-ID'] = ObjectSerializerPpl::toHeaderValue($x_correlation_id);
        }
        // header params
        if ($x_log_level !== null) {
            $headerParams['X-LogLevel'] = ObjectSerializerPpl::toHeaderValue($x_log_level);
        }



        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'text/json', 'application/problem+json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'text/json', 'application/problem+json'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \WoocommercePplVendor\GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializerPpl::buildQuery($formParams);
            }
        }

        // this endpoint requires Bearer (JWT) authentication (access token)
        if (!empty($this->config->getAccessToken())) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = ObjectSerializerPpl::buildQuery($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
