<?php
/**
 * OrderApi
 * PHP version 7.4
 *
 * @category Class
 * @package  PluginPpl\MyApi2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * CPL
 *
 * **Changelog**    * 2024-08-22 - SPRJ-13791 - validace PRTE / PRBC externích čísel - nelze použít najednou    - /shipment/batch    * 2024-07-01 - SPRJ-13838 - přidání    - /customer/address    * 2023-11-23 - SPRJ-12703 - CPL - /shipment - timestamp    - /shipment - Rozšíření výstupu o LastUpdateDate.    * 2023-07-13 - SPRJ-11888 - přidání    - /codelist/status - číselník statusů    * 2023-07-13 - SPRJ-11953 - přidání    - /order/cancel - storno objednávky
 *
 * The version of the OpenAPI document: v1
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace PluginPpl\MyApi2\Api;

use WoocommercePplVendor\GuzzleHttp\Client;
use WoocommercePplVendor\GuzzleHttp\ClientInterface;
use WoocommercePplVendor\GuzzleHttp\Exception\ConnectException;
use WoocommercePplVendor\GuzzleHttp\Exception\RequestException;
use WoocommercePplVendor\GuzzleHttp\Psr7\MultipartStream;
use WoocommercePplVendor\GuzzleHttp\Psr7\Request;
use WoocommercePplVendor\GuzzleHttp\RequestOptions;
use PluginPpl\MyApi2\ApiException;
use PluginPpl\MyApi2\Configuration;
use PluginPpl\MyApi2\HeaderSelector;
use PluginPpl\MyApi2\ObjectSerializerPpl;

/**
 * OrderApi Class Doc Comment
 *
 * @category Class
 * @package  PluginPpl\MyApi2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class OrderApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $hostIndex (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $hostIndex = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $hostIndex;
    }

    /**
     * Set the host index
     *
     * @param int $hostIndex Host index (required)
     */
    public function setHostIndex($hostIndex): void
    {
        $this->hostIndex = $hostIndex;
    }

    /**
     * Get the host index
     *
     * @return int Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation orderGet
     *
     * Sledování stavu objednávek
     *
     * @param  int $limit limit (required)
     * @param  int $offset offset (required)
     * @param  string[] $shipment_numbers Číslo/čísla balíků (optional)
     * @param  string[] $customer_references Reference odesílatele (optional)
     * @param  string[] $order_references Reference objednávky (optional)
     * @param  string[] $order_numbers Číslo objednávky (optional)
     * @param  int[] $order_ids ID objednávky (optional)
     * @param  \DateTime $date_from Datum od (optional)
     * @param  \DateTime $date_to Datum do (optional)
     * @param  \DateTime $send_date Datum odeslání (optional)
     * @param  string $product_type Typ produktu (optional)
     * @param  EpsApiMyApi2WebModelsEnumOrderStates $order_states Stav objednávky (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \PluginPpl\MyApi2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return \PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsOrderOrderModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel
     */
    public function orderGet($limit, $offset, $shipment_numbers = null, $customer_references = null, $order_references = null, $order_numbers = null, $order_ids = null, $date_from = null, $date_to = null, $send_date = null, $product_type = null, $order_states = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        list($response) = $this->orderGetWithHttpInfo($limit, $offset, $shipment_numbers, $customer_references, $order_references, $order_numbers, $order_ids, $date_from, $date_to, $send_date, $product_type, $order_states, $accept_language, $x_correlation_id, $x_log_level);
        return $response;
    }

    /**
     * Operation orderGetWithHttpInfo
     *
     * Sledování stavu objednávek
     *
     * @param  int $limit (required)
     * @param  int $offset (required)
     * @param  string[] $shipment_numbers Číslo/čísla balíků (optional)
     * @param  string[] $customer_references Reference odesílatele (optional)
     * @param  string[] $order_references Reference objednávky (optional)
     * @param  string[] $order_numbers Číslo objednávky (optional)
     * @param  int[] $order_ids ID objednávky (optional)
     * @param  \DateTime $date_from Datum od (optional)
     * @param  \DateTime $date_to Datum do (optional)
     * @param  \DateTime $send_date Datum odeslání (optional)
     * @param  string $product_type Typ produktu (optional)
     * @param  EpsApiMyApi2WebModelsEnumOrderStates $order_states Stav objednávky (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \PluginPpl\MyApi2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsOrderOrderModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel|\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel, HTTP status code, HTTP response headers (array of strings)
     */
    public function orderGetWithHttpInfo($limit, $offset, $shipment_numbers = null, $customer_references = null, $order_references = null, $order_numbers = null, $order_ids = null, $date_from = null, $date_to = null, $send_date = null, $product_type = null, $order_states = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        $request = $this->orderGetRequest($limit, $offset, $shipment_numbers, $customer_references, $order_references, $order_numbers, $order_ids, $date_from, $date_to, $send_date, $product_type, $order_states, $accept_language, $x_correlation_id, $x_log_level);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            switch($statusCode) {
                case 200:
                    if ('\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsOrderOrderModel' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsOrderOrderModel' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, '\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsOrderOrderModel', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 400:
                    if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 500:
                    if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                case 503:
                    if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ('\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel' !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel', []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
            }

            $returnType = '\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsOrderOrderModel';
            if ($returnType === '\SplFileObject') {
                $content = $response->getBody(); //stream goes to serializer
            } else {
                $content = (string) $response->getBody();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializerPpl::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsOrderOrderModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 503:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation orderGetAsync
     *
     * Sledování stavu objednávek
     *
     * @param  int $limit (required)
     * @param  int $offset (required)
     * @param  string[] $shipment_numbers Číslo/čísla balíků (optional)
     * @param  string[] $customer_references Reference odesílatele (optional)
     * @param  string[] $order_references Reference objednávky (optional)
     * @param  string[] $order_numbers Číslo objednávky (optional)
     * @param  int[] $order_ids ID objednávky (optional)
     * @param  \DateTime $date_from Datum od (optional)
     * @param  \DateTime $date_to Datum do (optional)
     * @param  \DateTime $send_date Datum odeslání (optional)
     * @param  string $product_type Typ produktu (optional)
     * @param  EpsApiMyApi2WebModelsEnumOrderStates $order_states Stav objednávky (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Promise\PromiseInterface
     */
    public function orderGetAsync($limit, $offset, $shipment_numbers = null, $customer_references = null, $order_references = null, $order_numbers = null, $order_ids = null, $date_from = null, $date_to = null, $send_date = null, $product_type = null, $order_states = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        return $this->orderGetAsyncWithHttpInfo($limit, $offset, $shipment_numbers, $customer_references, $order_references, $order_numbers, $order_ids, $date_from, $date_to, $send_date, $product_type, $order_states, $accept_language, $x_correlation_id, $x_log_level)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation orderGetAsyncWithHttpInfo
     *
     * Sledování stavu objednávek
     *
     * @param  int $limit (required)
     * @param  int $offset (required)
     * @param  string[] $shipment_numbers Číslo/čísla balíků (optional)
     * @param  string[] $customer_references Reference odesílatele (optional)
     * @param  string[] $order_references Reference objednávky (optional)
     * @param  string[] $order_numbers Číslo objednávky (optional)
     * @param  int[] $order_ids ID objednávky (optional)
     * @param  \DateTime $date_from Datum od (optional)
     * @param  \DateTime $date_to Datum do (optional)
     * @param  \DateTime $send_date Datum odeslání (optional)
     * @param  string $product_type Typ produktu (optional)
     * @param  EpsApiMyApi2WebModelsEnumOrderStates $order_states Stav objednávky (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Promise\PromiseInterface
     */
    public function orderGetAsyncWithHttpInfo($limit, $offset, $shipment_numbers = null, $customer_references = null, $order_references = null, $order_numbers = null, $order_ids = null, $date_from = null, $date_to = null, $send_date = null, $product_type = null, $order_states = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        $returnType = '\PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsOrderOrderModel';
        $request = $this->orderGetRequest($limit, $offset, $shipment_numbers, $customer_references, $order_references, $order_numbers, $order_ids, $date_from, $date_to, $send_date, $product_type, $order_states, $accept_language, $x_correlation_id, $x_log_level);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    if ($returnType === '\SplFileObject') {
                        $content = $response->getBody(); //stream goes to serializer
                    } else {
                        $content = (string) $response->getBody();
                        if ($returnType !== 'string') {
                            $content = json_decode($content);
                        }
                    }

                    return [
                        ObjectSerializerPpl::deserialize($content, $returnType, []),
                        $response->getStatusCode(),
                        $response->getHeaders()
                    ];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'orderGet'
     *
     * @param  int $limit (required)
     * @param  int $offset (required)
     * @param  string[] $shipment_numbers Číslo/čísla balíků (optional)
     * @param  string[] $customer_references Reference odesílatele (optional)
     * @param  string[] $order_references Reference objednávky (optional)
     * @param  string[] $order_numbers Číslo objednávky (optional)
     * @param  int[] $order_ids ID objednávky (optional)
     * @param  \DateTime $date_from Datum od (optional)
     * @param  \DateTime $date_to Datum do (optional)
     * @param  \DateTime $send_date Datum odeslání (optional)
     * @param  string $product_type Typ produktu (optional)
     * @param  EpsApiMyApi2WebModelsEnumOrderStates $order_states Stav objednávky (optional)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Psr7\Request
     */
    public function orderGetRequest($limit, $offset, $shipment_numbers = null, $customer_references = null, $order_references = null, $order_numbers = null, $order_ids = null, $date_from = null, $date_to = null, $send_date = null, $product_type = null, $order_states = null, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        // verify the required parameter 'limit' is set
        if ($limit === null || (is_array($limit) && count($limit) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $limit when calling orderGet'
            );
        }
        if ($limit > 1000) {
            throw new \InvalidArgumentException('invalid value for "$limit" when calling OrderApi.orderGet, must be smaller than or equal to 1000.');
        }
        if ($limit < 1) {
            throw new \InvalidArgumentException('invalid value for "$limit" when calling OrderApi.orderGet, must be bigger than or equal to 1.');
        }

        // verify the required parameter 'offset' is set
        if ($offset === null || (is_array($offset) && count($offset) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $offset when calling orderGet'
            );
        }
        if ($offset > 2147483647) {
            throw new \InvalidArgumentException('invalid value for "$offset" when calling OrderApi.orderGet, must be smaller than or equal to 2147483647.');
        }
        if ($offset < 0) {
            throw new \InvalidArgumentException('invalid value for "$offset" when calling OrderApi.orderGet, must be bigger than or equal to 0.');
        }

        if ($shipment_numbers !== null && count($shipment_numbers) > 50) {
            throw new \InvalidArgumentException('invalid value for "$shipment_numbers" when calling OrderApi.orderGet, number of items must be less than or equal to 50.');
        }

        if ($customer_references !== null && count($customer_references) > 50) {
            throw new \InvalidArgumentException('invalid value for "$customer_references" when calling OrderApi.orderGet, number of items must be less than or equal to 50.');
        }

        if ($order_references !== null && count($order_references) > 50) {
            throw new \InvalidArgumentException('invalid value for "$order_references" when calling OrderApi.orderGet, number of items must be less than or equal to 50.');
        }

        if ($order_numbers !== null && count($order_numbers) > 50) {
            throw new \InvalidArgumentException('invalid value for "$order_numbers" when calling OrderApi.orderGet, number of items must be less than or equal to 50.');
        }

        if ($order_ids !== null && count($order_ids) > 50) {
            throw new \InvalidArgumentException('invalid value for "$order_ids" when calling OrderApi.orderGet, number of items must be less than or equal to 50.');
        }


        $resourcePath = '/order';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $shipment_numbers,
            'ShipmentNumbers', // param base name
            'array', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $customer_references,
            'CustomerReferences', // param base name
            'array', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $order_references,
            'OrderReferences', // param base name
            'array', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $order_numbers,
            'OrderNumbers', // param base name
            'array', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $order_ids,
            'OrderIds', // param base name
            'array', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $date_from,
            'DateFrom', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $date_to,
            'DateTo', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $send_date,
            'SendDate', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $product_type,
            'ProductType', // param base name
            'string', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $order_states,
            'OrderStates', // param base name
            'EpsApiMyApi2WebModelsEnumOrderStates', // openApiType
            'form', // style
            true, // explode
            false // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $limit,
            'Limit', // param base name
            'integer', // openApiType
            'form', // style
            true, // explode
            true // required
        ) ?? []);
        // query params
        $queryParams = array_merge($queryParams, ObjectSerializerPpl::toQueryValue(
            $offset,
            'Offset', // param base name
            'integer', // openApiType
            'form', // style
            true, // explode
            true // required
        ) ?? []);

        // header params
        if ($accept_language !== null) {
            $headerParams['Accept-Language'] = ObjectSerializerPpl::toHeaderValue($accept_language);
        }
        // header params
        if ($x_correlation_id !== null) {
            $headerParams['X-Correlation-ID'] = ObjectSerializerPpl::toHeaderValue($x_correlation_id);
        }
        // header params
        if ($x_log_level !== null) {
            $headerParams['X-LogLevel'] = ObjectSerializerPpl::toHeaderValue($x_log_level);
        }



        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json', 'text/json', 'application/problem+json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json', 'text/json', 'application/problem+json'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \WoocommercePplVendor\GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializerPpl::buildQuery($formParams);
            }
        }

        // this endpoint requires Bearer (JWT) authentication (access token)
        if (!empty($this->config->getAccessToken())) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = ObjectSerializerPpl::buildQuery($queryParams);
        return new Request(
            'GET',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
