<?php
/**
 * ShipmentEventApi
 * PHP version 7.4
 *
 * @category Class
 * @package  PluginPpl\MyApi2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * CPL
 *
 * **Changelog**    * 2024-08-22 - SPRJ-13791 - validace PRTE / PRBC externích čísel - nelze použít najednou    - /shipment/batch    * 2024-07-01 - SPRJ-13838 - přidání    - /customer/address    * 2023-11-23 - SPRJ-12703 - CPL - /shipment - timestamp    - /shipment - Rozšíření výstupu o LastUpdateDate.    * 2023-07-13 - SPRJ-11888 - přidání    - /codelist/status - číselník statusů    * 2023-07-13 - SPRJ-11953 - přidání    - /order/cancel - storno objednávky
 *
 * The version of the OpenAPI document: v1
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace PluginPpl\MyApi2\Api;

use WoocommercePplVendor\GuzzleHttp\Client;
use WoocommercePplVendor\GuzzleHttp\ClientInterface;
use WoocommercePplVendor\GuzzleHttp\Exception\ConnectException;
use WoocommercePplVendor\GuzzleHttp\Exception\RequestException;
use WoocommercePplVendor\GuzzleHttp\Psr7\MultipartStream;
use WoocommercePplVendor\GuzzleHttp\Psr7\Request;
use WoocommercePplVendor\GuzzleHttp\RequestOptions;
use PluginPpl\MyApi2\ApiException;
use PluginPpl\MyApi2\Configuration;
use PluginPpl\MyApi2\HeaderSelector;
use PluginPpl\MyApi2\ObjectSerializerPpl;

/**
 * ShipmentEventApi Class Doc Comment
 *
 * @category Class
 * @package  PluginPpl\MyApi2
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ShipmentEventApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @var int Host index
     */
    protected $hostIndex;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     * @param int             $hostIndex (Optional) host index to select the list of hosts if defined in the OpenAPI spec
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null,
        $hostIndex = 0
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
        $this->hostIndex = $hostIndex;
    }

    /**
     * Set the host index
     *
     * @param int $hostIndex Host index (required)
     */
    public function setHostIndex($hostIndex): void
    {
        $this->hostIndex = $hostIndex;
    }

    /**
     * Get the host index
     *
     * @return int Host index
     */
    public function getHostIndex()
    {
        return $this->hostIndex;
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation shipmentShipmentNumberCancelPost
     *
     * Možnost stornovat balík, pokud nebyl fyzicky poslán
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \PluginPpl\MyApi2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function shipmentShipmentNumberCancelPost($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        $this->shipmentShipmentNumberCancelPostWithHttpInfo($shipment_number, $accept_language, $x_correlation_id, $x_log_level);
    }

    /**
     * Operation shipmentShipmentNumberCancelPostWithHttpInfo
     *
     * Možnost stornovat balík, pokud nebyl fyzicky poslán
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \PluginPpl\MyApi2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function shipmentShipmentNumberCancelPostWithHttpInfo($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        $request = $this->shipmentShipmentNumberCancelPostRequest($shipment_number, $accept_language, $x_correlation_id, $x_log_level);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 400:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 503:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation shipmentShipmentNumberCancelPostAsync
     *
     * Možnost stornovat balík, pokud nebyl fyzicky poslán
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Promise\PromiseInterface
     */
    public function shipmentShipmentNumberCancelPostAsync($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        return $this->shipmentShipmentNumberCancelPostAsyncWithHttpInfo($shipment_number, $accept_language, $x_correlation_id, $x_log_level)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation shipmentShipmentNumberCancelPostAsyncWithHttpInfo
     *
     * Možnost stornovat balík, pokud nebyl fyzicky poslán
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Promise\PromiseInterface
     */
    public function shipmentShipmentNumberCancelPostAsyncWithHttpInfo($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        $returnType = '';
        $request = $this->shipmentShipmentNumberCancelPostRequest($shipment_number, $accept_language, $x_correlation_id, $x_log_level);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'shipmentShipmentNumberCancelPost'
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Psr7\Request
     */
    public function shipmentShipmentNumberCancelPostRequest($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null)
    {
        // verify the required parameter 'shipment_number' is set
        if ($shipment_number === null || (is_array($shipment_number) && count($shipment_number) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $shipment_number when calling shipmentShipmentNumberCancelPost'
            );
        }
        if (strlen($shipment_number) < 1) {
            throw new \InvalidArgumentException('invalid length for "$shipment_number" when calling ShipmentEventApi.shipmentShipmentNumberCancelPost, must be bigger than or equal to 1.');
        }


        $resourcePath = '/shipment/{shipmentNumber}/cancel';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // header params
        if ($accept_language !== null) {
            $headerParams['Accept-Language'] = ObjectSerializerPpl::toHeaderValue($accept_language);
        }
        // header params
        if ($x_correlation_id !== null) {
            $headerParams['X-Correlation-ID'] = ObjectSerializerPpl::toHeaderValue($x_correlation_id);
        }
        // header params
        if ($x_log_level !== null) {
            $headerParams['X-LogLevel'] = ObjectSerializerPpl::toHeaderValue($x_log_level);
        }

        // path params
        if ($shipment_number !== null) {
            $resourcePath = str_replace(
                '{' . 'shipmentNumber' . '}',
                ObjectSerializerPpl::toPathValue($shipment_number),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/problem+json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/problem+json'],
                []
            );
        }

        // for model (json/xml)
        if (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \WoocommercePplVendor\GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializerPpl::buildQuery($formParams);
            }
        }

        // this endpoint requires Bearer (JWT) authentication (access token)
        if (!empty($this->config->getAccessToken())) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = ObjectSerializerPpl::buildQuery($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Operation shipmentShipmentNumberRedirectPost
     *
     * Možnost doplnit informace k balíku
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     * @param  \PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsShipmentEventRedirectShipmentEventModel $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model  (optional)
     *
     * @throws \PluginPpl\MyApi2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return void
     */
    public function shipmentShipmentNumberRedirectPost($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null, $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model = null)
    {
        $this->shipmentShipmentNumberRedirectPostWithHttpInfo($shipment_number, $accept_language, $x_correlation_id, $x_log_level, $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model);
    }

    /**
     * Operation shipmentShipmentNumberRedirectPostWithHttpInfo
     *
     * Možnost doplnit informace k balíku
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     * @param  \PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsShipmentEventRedirectShipmentEventModel $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model  (optional)
     *
     * @throws \PluginPpl\MyApi2\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of null, HTTP status code, HTTP response headers (array of strings)
     */
    public function shipmentShipmentNumberRedirectPostWithHttpInfo($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null, $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model = null)
    {
        $request = $this->shipmentShipmentNumberRedirectPostRequest($shipment_number, $accept_language, $x_correlation_id, $x_log_level, $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model);

        try {
            $options = $this->createHttpClientOption();
            try {
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? (string) $e->getResponse()->getBody() : null
                );
            } catch (ConnectException $e) {
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    (int) $e->getCode(),
                    null,
                    null
                );
            }

            $statusCode = $response->getStatusCode();

            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        (string) $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    (string) $response->getBody()
                );
            }

            return [null, $statusCode, $response->getHeaders()];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 400:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 500:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 503:
                    $data = ObjectSerializerPpl::deserialize(
                        $e->getResponseBody(),
                        '\PluginPpl\MyApi2\Model\EpsApiInfrastructureWebApiModelProblemJsonModel',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }

    /**
     * Operation shipmentShipmentNumberRedirectPostAsync
     *
     * Možnost doplnit informace k balíku
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     * @param  \PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsShipmentEventRedirectShipmentEventModel $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model  (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Promise\PromiseInterface
     */
    public function shipmentShipmentNumberRedirectPostAsync($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null, $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model = null)
    {
        return $this->shipmentShipmentNumberRedirectPostAsyncWithHttpInfo($shipment_number, $accept_language, $x_correlation_id, $x_log_level, $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model)
            ->then(
                function ($response) {
                    return $response[0];
                }
            );
    }

    /**
     * Operation shipmentShipmentNumberRedirectPostAsyncWithHttpInfo
     *
     * Možnost doplnit informace k balíku
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     * @param  \PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsShipmentEventRedirectShipmentEventModel $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model  (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Promise\PromiseInterface
     */
    public function shipmentShipmentNumberRedirectPostAsyncWithHttpInfo($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null, $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model = null)
    {
        $returnType = '';
        $request = $this->shipmentShipmentNumberRedirectPostRequest($shipment_number, $accept_language, $x_correlation_id, $x_log_level, $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model);

        return $this->client
            ->sendAsync($request, $this->createHttpClientOption())
            ->then(
                function ($response) use ($returnType) {
                    return [null, $response->getStatusCode(), $response->getHeaders()];
                },
                function ($exception) {
                    $response = $exception->getResponse();
                    $statusCode = $response->getStatusCode();
                    throw new ApiException(
                        sprintf(
                            '[%d] Error connecting to the API (%s)',
                            $statusCode,
                            $exception->getRequest()->getUri()
                        ),
                        $statusCode,
                        $response->getHeaders(),
                        (string) $response->getBody()
                    );
                }
            );
    }

    /**
     * Create request for operation 'shipmentShipmentNumberRedirectPost'
     *
     * @param  string $shipment_number  (required)
     * @param  string $accept_language Language specification, default language: cs-CZ (optional)
     * @param  string $x_correlation_id Correlation Id of request (optional)
     * @param  XLogLevelSchema $x_log_level The forced log level (optional)
     * @param  \PluginPpl\MyApi2\Model\EpsApiMyApi2WebModelsShipmentEventRedirectShipmentEventModel $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model  (optional)
     *
     * @throws \InvalidArgumentException
     * @return \WoocommercePplVendor\GuzzleHttp\Psr7\Request
     */
    public function shipmentShipmentNumberRedirectPostRequest($shipment_number, $accept_language = null, $x_correlation_id = null, $x_log_level = null, $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model = null)
    {
        // verify the required parameter 'shipment_number' is set
        if ($shipment_number === null || (is_array($shipment_number) && count($shipment_number) === 0)) {
            throw new \InvalidArgumentException(
                'Missing the required parameter $shipment_number when calling shipmentShipmentNumberRedirectPost'
            );
        }
        if (strlen($shipment_number) < 1) {
            throw new \InvalidArgumentException('invalid length for "$shipment_number" when calling ShipmentEventApi.shipmentShipmentNumberRedirectPost, must be bigger than or equal to 1.');
        }


        $resourcePath = '/shipment/{shipmentNumber}/redirect';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;


        // header params
        if ($accept_language !== null) {
            $headerParams['Accept-Language'] = ObjectSerializerPpl::toHeaderValue($accept_language);
        }
        // header params
        if ($x_correlation_id !== null) {
            $headerParams['X-Correlation-ID'] = ObjectSerializerPpl::toHeaderValue($x_correlation_id);
        }
        // header params
        if ($x_log_level !== null) {
            $headerParams['X-LogLevel'] = ObjectSerializerPpl::toHeaderValue($x_log_level);
        }

        // path params
        if ($shipment_number !== null) {
            $resourcePath = str_replace(
                '{' . 'shipmentNumber' . '}',
                ObjectSerializerPpl::toPathValue($shipment_number),
                $resourcePath
            );
        }


        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/problem+json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/problem+json'],
                ['application/json-patch+json', 'application/json', 'text/json', 'application/*+json']
            );
        }

        // for model (json/xml)
        if (isset($eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model)) {
            if ($headers['Content-Type'] === 'application/json') {
                $httpBody = \WoocommercePplVendor\GuzzleHttp\json_encode(ObjectSerializerPpl::sanitizeForSerialization($eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model));
            } else {
                $httpBody = $eps_api_my_api2_web_models_shipment_event_redirect_shipment_event_model;
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $formParamValueItems = is_array($formParamValue) ? $formParamValue : [$formParamValue];
                    foreach ($formParamValueItems as $formParamValueItem) {
                        $multipartContents[] = [
                            'name' => $formParamName,
                            'contents' => $formParamValueItem
                        ];
                    }
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \WoocommercePplVendor\GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = ObjectSerializerPpl::buildQuery($formParams);
            }
        }

        // this endpoint requires Bearer (JWT) authentication (access token)
        if (!empty($this->config->getAccessToken())) {
            $headers['Authorization'] = 'Bearer ' . $this->config->getAccessToken();
        }

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

        $query = ObjectSerializerPpl::buildQuery($queryParams);
        return new Request(
            'POST',
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        );
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }

        return $options;
    }
}
