<?php
namespace  WoocommercePpl\Admin\Assets;

defined("WPINC") or die();

class JsTemplate
{
    public const COLLECTIONURL  = "https://www1.ppl.cz";
    private static $data = [];

    /**
     * @param $data
     * @return void
     */
    public static function scripts($key = null, $data = null)
    {
        if ($key && $data) {
            if (!isset(self::$data[$key])) {
                self::$data[$key] = [$data];
            } else {
                self::$data[$key][] = $data;
            }
        }
        static $inserted = false;
        if ($inserted) {
            return;
        }
        $inserted = true;
        self::$data["ajax"] = [
            "ajax_url" => admin_url( 'admin-ajax.php' ),
        ];
        add_action("admin_footer", [JsTemplate::class, "admin_scripts"]);
    }

    public static function admin_scripts()
    {
        $setting = require __DIR__ . '/build/index.asset.php';
        wp_enqueue_script("ppl_map_js");
        wp_enqueue_style("ppl_map_css");
        wp_enqueue_script("woocommerce_ppl_scripts", plugin_dir_url(__FILE__) . 'build/index.js', array_merge($setting['dependencies'], ["jquery"]), $setting['version']);
        wp_localize_script("woocommerce_ppl_scripts", "woocommerce_ppl_data", self::$data);
        wp_enqueue_script("woocommerce_ppl_plugin", plugin_dir_url(realpath(__DIR__ . '/../'))  . "Admin/Assets/static/js/bundle.js", [] , ppl_get_version());

        wp_localize_script("woocommerce_ppl_plugin", "ppl_plugin_data", [
            "nonce" => wp_create_nonce("wp_rest"),
            "url" => rtrim(get_rest_url(), '/'),
            "pluginPath" => plugin_dir_url(realpath(__DIR__ . '/../'))  . "Admin/Assets/static",
            "newCollectionUrl" => self::COLLECTIONURL,
        ]);

    }

}