import { components } from "../schema";

type ShipmentModel = components["schemas"]["ShipmentModel"];

const renderForm = (orderId: number, shipment: ShipmentModel) => {
    const id = `#ppl-order-panel-shipment-div-${orderId}-overlay`;
    // @ts-ignore
    const pplPlugin = window.pplPlugin = window.pplPlugin || [];
    pplPlugin.push(["wpUpdateStyle", `ppl-order-panel-shipment-div-${orderId}-overlay`]);
    let unmount:any = null;
    const item = jQuery("<div>").prependTo("body")[0];
    pplPlugin.push(["newShipment", item, {
        "shipment": shipment,
        "returnFunc": function(data) {
            unmount = data.unmount;
        },
        "onFinish": function() {
            // @ts-ignore
            wp.ajax.post({
                action: "ppl_order_panel",
                orderId,
            }).done(function (response) {
                unmount();
                jQuery(id).html(response.html);
            });
        }
    }]);
}

export const form = (orderId:number, shipment:ShipmentModel) => {
    const id = `#ppl-order-panel-shipment-div-${orderId}-overlay`;
    if (shipment)
        renderForm(orderId, shipment);
    else {
        // @ts-ignore
        wp.ajax.post({
            action: "ppl_order_panel_prepare_package",
            orderId
        }).done(function(response) {
            jQuery(id).html(response.html);
            renderForm(orderId, response.shipment);
        });
    }
}

