import { dispatch } from "@wordpress/data";

export function ppl_parcelshop(element, props:  {meta_id:number, order_id: number, nonce: string}) {

    const { meta_id, order_id, nonce } = props;
    const divId = `#ppl_parcelshop_${meta_id}`;
    let container = jQuery(element);

    const error = () => {
        // @ts-ignore
        dispatch("core/notices").createNotice(
            'error', // Can be one of: success, info, warning, error.
            'Problém se změnou parcelshop/parcelboxu.', // Text string to display.
            {
                isDismissible: true, // Whether the user can dismiss the notice.
            }
        );
    }

    const clickName = `ppl_parcelshop_${meta_id}`;
    jQuery(`.${clickName}`).off(`.${clickName}`);

    const onComplete = (shipping_address:any) => {

        jQuery.ajax({
            // @ts-ignore
            url: woocommerce_ppl_data.ajax.ajax_url,
            type: "post",
            dataType: "json",
            data: {
                action: "render_parcel_shop",
                meta_id: meta_id,
                order_id,
                shipping_address,
                nonce
            },
            error,
            success: (data) => {
                if (data.success) {
                    container.replaceWith(data.data.content);
                    jQuery(`#ppl_parcelshop_${meta_id} button`).css("display", "inline")
                }
                else
                {
                    // @ts-ignore
                    error();
                }

            }
        });
    }

    container.addClass(clickName).on(`click.${clickName}`, ".ppl_parcelshop_parcelshop",function(e) {
        e.preventDefault();
        PplMap(onComplete, { parcelShop: true })
    }).on(`click.click.${clickName}`, ".ppl_parcelshop_parcelbox",function(e) {
        e.preventDefault();
        PplMap(onComplete, { parcelBox: true })
    }).on(`click.click.${clickName}`, ".ppl_parcelshop_clear",function(e) {
        e.preventDefault();
        onComplete(null);
    });

    const parent = container.closest(`tr[data-order_item_id="${meta_id}"]`);
    parent.addClass(clickName).one(`click.${clickName}`, "a.edit-order-item",()=>{
        container.find("button").css("display", "inline");
        setTimeout(() => {
            parent.find(`select`).filter((x, y)=> {
                return y.name === `shipping_method[${meta_id}]`;
            }).addClass(clickName).on(`change.${clickName}`, function() {
                const val = jQuery(this).val();
                if (val.includes("woocommerce_ppl_")) {
                    jQuery(divId).css('display', 'block');
                } else  {
                    jQuery(divId).css('display', 'none');
                }
            })
        }, 300);
    });
}