import {addPackage, cancelPackage, removePackage, removeShipment} from "./changePackages";
import {form} from "./form";
import {create_labels, create_labels2, test_labels, set_print_setting} from "./labels";

export const ppl_connect_div = (element, props:  {orderId: number}) => {

    const { orderId } = props;
    jQuery(window).off(`ppl-refresh-${orderId}`).on(`ppl-refresh-${orderId}`, () => {
        ppl_connect_div(null, {
            orderId
        } );
    })

    jQuery(window).find(`ppl-refresh-${orderId}`)


    const id =`#ppl-order-panel-shipment-div-${orderId}-overlay`;
    jQuery(`${id} *`).off('click.ppl-events').off("change.ppl-events");

    jQuery(`${id} .ppl_available_print_setting`).off("click.ppl-event").on("click.ppl-events", function(ev) {
        ev.preventDefault();
        const item = this;
        const optionals = jQuery(item).data("optionals");
        const value =  jQuery(item).data("value");
        set_print_setting(props.orderId, value, optionals);
    })



    jQuery(`${id} .add-package`).on('click.ppl-events', (e)=> {
        e.preventDefault();
        const { orderid: orderId, shipmentid: shipmentId } = jQuery(e.currentTarget).data();
        addPackage(orderId, shipmentId);
    });

    jQuery(`${id} .remove-package`).on('click.ppl-events', (e)=> {
        e.preventDefault();
        const { orderid: orderId, shipmentid: shipmentId } = jQuery(e.currentTarget).data();
        removePackage(orderId, shipmentId);
    });

    jQuery(`${id} .detail-shipment`).on('click.ppl-events', (e)=> {
        e.preventDefault();
        const {orderid: orderId, shipment} = jQuery(e.currentTarget).data();
        form(orderId, shipment);
    });

    jQuery(`${id} .cancel-package`).on('click.ppl-events', (e)=> {
        e.preventDefault();

        const {orderid: orderId, shipmentid: shipmentId, packageid: packageId } = jQuery(e.currentTarget).data();
        cancelPackage(orderId, shipmentId, packageId);
    });

    jQuery(`${id} .test-labels`).on('click.ppl-events', (e)=> {
        e.preventDefault();
        const {orderid: orderId, shipmentid: shipmentId} = jQuery(e.currentTarget).data();
        create_labels(orderId, shipmentId);
    })

    jQuery(`${id} .create-labels`).on('click.ppl-events', function(e) {
        e.preventDefault();
        const {orderid: orderId, shipment } = jQuery(e.currentTarget).data();
        create_labels2(orderId, shipment);
    });

    jQuery(`${id} .remove-shipment`).on('click.ppl-events', (e)=> {
        e.preventDefault();
        const {orderid: orderId, shipmentid: shipmentId } = jQuery(e.currentTarget).data();
        removeShipment(orderId, shipmentId);
    })

    /*
    jQuery(`${id} .create-labels`).on('click.ppl-events', (e)=> {
        e.preventDefault();
        const {orderid: orderId, shipmentid: shipmentId} = jQuery(e.currentTarget).data();
        create_labels(orderId, shipmentId);
    });
    */

    jQuery(`${id} .refresh-shipments`).on('click.ppl-events', (e)=> {
        e.preventDefault();
        const {orderid: orderId, shipmentid: shipmentId} = jQuery(e.currentTarget).data();
        test_labels(orderId, shipmentId);
    })

    jQuery(`${id} .refresh-shipments-labels`).each(function (){
        const {orderid: orderId, shipmentid: shipmentId} = jQuery(this).data();
        setTimeout(()=> {
            test_labels(orderId, shipmentId);
        }, 2000);
    });

    jQuery(`${id} #ppl_available_print_setting`).on("change.ppl-events", function () {
        const print = jQuery(this).val();

        jQuery(`${id} .ppl-label-download`).each(function () {

            // @ts-ignore
            const url  = new URL(this.href);
            if (print)
                url.searchParams.set('ppl_print', `${print}`);
            else
                url.searchParams.delete("ppl_print");
            // @ts-ignore
            this.href = url + '';
        })
    })

}