<?php
namespace WoocommercePpl\Admin\RestController;
defined("WPINC") or die();


use WoocommercePpl\Data\ShipmentData;
use WoocommercePpl\Model\Model\ShipmentModel;
use WoocommercePpl\Serializer;

class WcOrderV1RestController extends PPLRestController
{

    protected $namespace = "woocommerce-ppl/v1";

    protected $base = "shipment";

    public function register_routes()
    {
        register_rest_route($this->namespace, '/' . $this->base. "/(?P<id>\d+)/shipments", [
            "methods" => \WP_REST_Server::READABLE,
            "callback" => [$this, "get_shipments"],
            "permission_callback"=>[$this, "check_permission"],
            "args"=> [
                "id" => [
                    "validate_callback" => function($params, $request, $key) {
                        return is_numeric($params) && (new \WC_Order($params))->get_id();
                    }
                ]
            ]
        ]);
    }

    public function get_shipments(\WP_REST_Request $request)
    {
        $shipments = ShipmentData::find_shipments_by_wc_order($request->get_param("id"));
        foreach ($shipments as $key =>$value) {
            $value = Serializer::getInstance()->denormalize($value, ShipmentModel::class);
            $value = Serializer::getInstance()->normalize($value, 'array');
            $shipments[$key] = $value;
        }
        $response = new \WP_REST_Response();
        $response->set_data($shipments);
        return $response;
    }

}