<?php
namespace WoocommercePpl\Data;
defined("WPINC") or die();


class ParcelDataStore extends PPLDataStore {


    protected $id_name = "ppl_parcel_id";

    protected $table_name = "ppl_parcel";


    public static function stores($stores)
    {
        return array_merge($stores, ["ppl-parcel" =>  self::class]);
    }

    public static function register()
    {
        add_filter('woocommerce_data_stores', [self::class, "stores"]);
    }

    public static function getAccessPointByCode($code)
    {
        global $wpdb;
        $sql = $wpdb->prepare("select * from {$wpdb->prefix}woocommerce_ppl_parcel where code = %s and hidden = 0", $code);
        $output = [];
        foreach ($wpdb->get_results($sql, ARRAY_A) as $item)
        {
            wp_cache_add($item["ppl_parcel_id"], $item, "ppl_parcel");
            $output[] = new ParcelData($item["ppl_parcel_id"]);
        }

        return reset($output);

    }
}