<?php
namespace WoocommercePpl\Front\Operation;

defined("WPINC") or die();


use WoocommercePpl\Model\Model\ParcelDataModel;
use WoocommercePpl\Serializer;
use WoocommercePpl\Traits\ParcelDataModelTrait;

class ParcelShopOperation {

    use ParcelDataModelTrait;

    public static function update_order(\WC_Order $order, \WP_REST_Request $request) {
        $parcelshopData = ppl_get_cart_parceldata();
        if ($parcelshopData)
            self::setParcelshopOrderData($order, $parcelshopData);
    }

    public static function old_posted_data($data)
    {
        if (isset($_POST["ppl_parcelshop"])) {
            $content = $_POST["ppl_parcelshop"];
            $parcelshop = json_decode(urldecode($content), true);
            if ($parcelshop) {
                $content = Serializer::getInstance()->denormalize($parcelshop, ParcelDataModel::class);
                ppl_set_cart_parceldata($content);

            }
            else {
                ppl_set_cart_parceldata(null);
            }
            $data["ppl_parcelshop"] = $_POST["ppl_parcelshop"];
        }

        return $data;
    }

    public static function old_update_checkout($data) {

        parse_str($data, $arraydata);
        if (isset($arraydata['ppl_parcelshop'])) {
            $decoded = json_decode(urldecode($arraydata['ppl_parcelshop']), true);
            if ($decoded) {
                $unserialized = Serializer::getInstance()->denormalize($decoded, ParcelDataModel::class);
                ppl_set_cart_parceldata($unserialized);
            }
            else
                ppl_set_cart_parceldata(null);
        }
        return;
    }

    public static function old_shipping_item(\WC_Order_Item_Shipping $item, $package_key, $package, $order)
    {

        $data = ppl_get_cart_parceldata();
        if ($data) {
            self::setParcelDataModel($item, $data);
        }
    }

    public static function register()
    {
        add_action('woocommerce_store_api_checkout_update_order_from_request', [self::class, 'update_order'], 10, 2);

        add_action('woocommerce_checkout_create_order_shipping_item', [self::class, "old_shipping_item"], 10, 4);
        add_filter("woocommerce_checkout_posted_data", [self::class, "old_posted_data"]);
        add_action('woocommerce_checkout_update_order_review', [self::class, "old_update_checkout"]);

    }
}