<?php

namespace WoocommercePpl\Model;

defined("WPINC") or die();

class Client extends \WoocommercePpl\Model\Runtime\Client\Client
{
    public static function create($httpClient = null, array $additionalPlugins = array(), array $additionalNormalizers = array())
    {
        if (null === $httpClient) {
            $httpClient = \WoocommercePplVendor\Http\Discovery\Psr18ClientDiscovery::find();
            $plugins = array();
            if (count($additionalPlugins) > 0) {
                $plugins = array_merge($plugins, $additionalPlugins);
            }
            $httpClient = new \WoocommercePplVendor\Http\Client\Common\PluginClient($httpClient, $plugins);
        }
        $requestFactory = \WoocommercePplVendor\Http\Discovery\Psr17FactoryDiscovery::findRequestFactory();
        $streamFactory = \WoocommercePplVendor\Http\Discovery\Psr17FactoryDiscovery::findStreamFactory();
        $normalizers = array(new WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\ArrayDenormalizer(), new \WoocommercePpl\Model\Normalizer\JaneObjectNormalizer());
        if (count($additionalNormalizers) > 0) {
            $normalizers = array_merge($normalizers, $additionalNormalizers);
        }
        $serializer = new \WoocommercePplVendor\Symfony\Component\Serializer\Serializer($normalizers, array(new \WoocommercePplVendor\Symfony\Component\Serializer\Encoder\JsonEncoder(new \WoocommercePplVendor\Symfony\Component\Serializer\Encoder\JsonEncode(), new \WoocommercePplVendor\Symfony\Component\Serializer\Encoder\JsonDecode(array('json_decode_associative' => true)))));
        return new static($httpClient, $requestFactory, $serializer, $streamFactory);
    }
}