<?php

namespace WoocommercePpl\Model\Normalizer;

defined("WPINC") or die();

use WoocommercePpl\Model\Runtime\Normalizer\CheckArray;
use WoocommercePpl\Model\Runtime\Normalizer\ValidatorTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerAwareInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerAwareTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerAwareInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerAwareTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerInterface;
class JaneObjectNormalizer implements DenormalizerInterface, NormalizerInterface, DenormalizerAwareInterface, NormalizerAwareInterface
{
    use DenormalizerAwareTrait;
    use NormalizerAwareTrait;
    use CheckArray;
    use ValidatorTrait;
    protected $normalizers = array('WoocommercePpl\\Model\\Model\\ProductModel' => 'WoocommercePpl\\Model\\Normalizer\\ProductModelNormalizer', 'WoocommercePpl\\Model\\Model\\CategoryModel' => 'WoocommercePpl\\Model\\Normalizer\\CategoryModelNormalizer', 'WoocommercePpl\\Model\\Model\\ParcelDataModel' => 'WoocommercePpl\\Model\\Normalizer\\ParcelDataModelNormalizer', 'WoocommercePpl\\Model\\Model\\ParcelDataModelGps' => 'WoocommercePpl\\Model\\Normalizer\\ParcelDataModelGpsNormalizer', 'WoocommercePpl\\Model\\Model\\MyApi2' => 'WoocommercePpl\\Model\\Normalizer\\MyApi2Normalizer', 'WoocommercePpl\\Model\\Model\\WhisperSettingModel' => 'WoocommercePpl\\Model\\Normalizer\\WhisperSettingModelNormalizer', 'WoocommercePpl\\Model\\Model\\WhisperAddressModel' => 'WoocommercePpl\\Model\\Normalizer\\WhisperAddressModelNormalizer', 'WoocommercePpl\\Model\\Model\\UpdateShipmentModel' => 'WoocommercePpl\\Model\\Normalizer\\UpdateShipmentModelNormalizer', 'WoocommercePpl\\Model\\Model\\UpdateParcelModel' => 'WoocommercePpl\\Model\\Normalizer\\UpdateParcelModelNormalizer', 'WoocommercePpl\\Model\\Model\\UpdateShipmentSenderModel' => 'WoocommercePpl\\Model\\Normalizer\\UpdateShipmentSenderModelNormalizer', 'WoocommercePpl\\Model\\Model\\UpdateShipmentBankAccountModel' => 'WoocommercePpl\\Model\\Normalizer\\UpdateShipmentBankAccountModelNormalizer', 'WoocommercePpl\\Model\\Model\\UpdateShipmentParcelModel' => 'WoocommercePpl\\Model\\Normalizer\\UpdateShipmentParcelModelNormalizer', 'WoocommercePpl\\Model\\Model\\CreateShipmentLabelBatchModel' => 'WoocommercePpl\\Model\\Normalizer\\CreateShipmentLabelBatchModelNormalizer', 'WoocommercePpl\\Model\\Model\\ShipmentLabelRefreshBatchModel' => 'WoocommercePpl\\Model\\Normalizer\\ShipmentLabelRefreshBatchModelNormalizer', 'WoocommercePpl\\Model\\Model\\PrepareShipmentBatchModel' => 'WoocommercePpl\\Model\\Normalizer\\PrepareShipmentBatchModelNormalizer', 'WoocommercePpl\\Model\\Model\\PrepareShipmentBatchItemModel' => 'WoocommercePpl\\Model\\Normalizer\\PrepareShipmentBatchItemModelNormalizer', 'WoocommercePpl\\Model\\Model\\PrepareShipmentBatchReturnModel' => 'WoocommercePpl\\Model\\Normalizer\\PrepareShipmentBatchReturnModelNormalizer', 'WoocommercePpl\\Model\\Model\\RefreshShipmentBatchReturnModel' => 'WoocommercePpl\\Model\\Normalizer\\RefreshShipmentBatchReturnModelNormalizer', 'WoocommercePpl\\Model\\Model\\PackageModel' => 'WoocommercePpl\\Model\\Normalizer\\PackageModelNormalizer', 'WoocommercePpl\\Model\\Model\\ParcelAddressModel' => 'WoocommercePpl\\Model\\Normalizer\\ParcelAddressModelNormalizer', 'WoocommercePpl\\Model\\Model\\LabelPrintModel' => 'WoocommercePpl\\Model\\Normalizer\\LabelPrintModelNormalizer', 'WoocommercePpl\\Model\\Model\\CollectionAddressModel' => 'WoocommercePpl\\Model\\Normalizer\\CollectionAddressModelNormalizer', 'WoocommercePpl\\Model\\Model\\SenderAddressModel' => 'WoocommercePpl\\Model\\Normalizer\\SenderAddressModelNormalizer', 'WoocommercePpl\\Model\\Model\\RecipientAddressModel' => 'WoocommercePpl\\Model\\Normalizer\\RecipientAddressModelNormalizer', 'WoocommercePpl\\Model\\Model\\BankAccountModel' => 'WoocommercePpl\\Model\\Normalizer\\BankAccountModelNormalizer', 'WoocommercePpl\\Model\\Model\\ShipmentCartModel' => 'WoocommercePpl\\Model\\Normalizer\\ShipmentCartModelNormalizer', 'WoocommercePpl\\Model\\Model\\ShipmentModel' => 'WoocommercePpl\\Model\\Normalizer\\ShipmentModelNormalizer', 'WoocommercePpl\\Model\\Model\\CurrencyModel' => 'WoocommercePpl\\Model\\Normalizer\\CurrencyModelNormalizer', 'WoocommercePpl\\Model\\Model\\ShipmentPhaseModel' => 'WoocommercePpl\\Model\\Normalizer\\ShipmentPhaseModelNormalizer', 'WoocommercePpl\\Model\\Model\\SyncPhasesModel' => 'WoocommercePpl\\Model\\Normalizer\\SyncPhasesModelNormalizer', 'WoocommercePpl\\Model\\Model\\UpdateSyncPhasesModel' => 'WoocommercePpl\\Model\\Normalizer\\UpdateSyncPhasesModelNormalizer', 'WoocommercePpl\\Model\\Model\\UpdateSyncPhasesModelPhasesItem' => 'WoocommercePpl\\Model\\Normalizer\\UpdateSyncPhasesModelPhasesItemNormalizer', 'WoocommercePpl\\Model\\Model\\CountryModel' => 'WoocommercePpl\\Model\\Normalizer\\CountryModelNormalizer', 'WoocommercePpl\\Model\\Model\\ShipmentMethodModel' => 'WoocommercePpl\\Model\\Normalizer\\ShipmentMethodModelNormalizer', 'WoocommercePpl\\Model\\Model\\NewCollectionModel' => 'WoocommercePpl\\Model\\Normalizer\\NewCollectionModelNormalizer', 'WoocommercePpl\\Model\\Model\\CollectionModel' => 'WoocommercePpl\\Model\\Normalizer\\CollectionModelNormalizer', '\\Jane\\Component\\JsonSchemaRuntime\\Reference' => '\\WoocommercePpl\\Model\\Runtime\\Normalizer\\ReferenceNormalizer'), $normalizersCache = array();
    public function supportsDenormalization($data, $type, $format = null, array $context = array()) : bool
    {
        return array_key_exists($type, $this->normalizers);
    }
    public function supportsNormalization($data, $format = null, array $context = array()) : bool
    {
        return is_object($data) && array_key_exists(get_class($data), $this->normalizers);
    }
    /**
     * @return array|string|int|float|bool|\ArrayObject|null
     */
    public function normalize($object, $format = null, array $context = array())
    {
        $normalizerClass = $this->normalizers[get_class($object)];
        $normalizer = $this->getNormalizer($normalizerClass);
        return $normalizer->normalize($object, $format, $context);
    }
    /**
     * @return mixed
     */
    public function denormalize($data, $class, $format = null, array $context = array())
    {
        $denormalizerClass = $this->normalizers[$class];
        $denormalizer = $this->getNormalizer($denormalizerClass);
        return $denormalizer->denormalize($data, $class, $format, $context);
    }
    private function getNormalizer(string $normalizerClass)
    {
        return $this->normalizersCache[$normalizerClass] ?? $this->initNormalizer($normalizerClass);
    }
    private function initNormalizer(string $normalizerClass)
    {
        $normalizer = new $normalizerClass();
        $normalizer->setNormalizer($this->normalizer);
        $normalizer->setDenormalizer($this->denormalizer);
        $this->normalizersCache[$normalizerClass] = $normalizer;
        return $normalizer;
    }
    public function getSupportedTypes(?string $format = null) : array
    {
        return array('WoocommercePpl\\Model\\Model\\ProductModel' => false, 'WoocommercePpl\\Model\\Model\\CategoryModel' => false, 'WoocommercePpl\\Model\\Model\\ParcelDataModel' => false, 'WoocommercePpl\\Model\\Model\\ParcelDataModelGps' => false, 'WoocommercePpl\\Model\\Model\\MyApi2' => false, 'WoocommercePpl\\Model\\Model\\WhisperSettingModel' => false, 'WoocommercePpl\\Model\\Model\\WhisperAddressModel' => false, 'WoocommercePpl\\Model\\Model\\UpdateShipmentModel' => false, 'WoocommercePpl\\Model\\Model\\UpdateParcelModel' => false, 'WoocommercePpl\\Model\\Model\\UpdateShipmentSenderModel' => false, 'WoocommercePpl\\Model\\Model\\UpdateShipmentBankAccountModel' => false, 'WoocommercePpl\\Model\\Model\\UpdateShipmentParcelModel' => false, 'WoocommercePpl\\Model\\Model\\CreateShipmentLabelBatchModel' => false, 'WoocommercePpl\\Model\\Model\\ShipmentLabelRefreshBatchModel' => false, 'WoocommercePpl\\Model\\Model\\PrepareShipmentBatchModel' => false, 'WoocommercePpl\\Model\\Model\\PrepareShipmentBatchItemModel' => false, 'WoocommercePpl\\Model\\Model\\PrepareShipmentBatchReturnModel' => false, 'WoocommercePpl\\Model\\Model\\RefreshShipmentBatchReturnModel' => false, 'WoocommercePpl\\Model\\Model\\PackageModel' => false, 'WoocommercePpl\\Model\\Model\\ParcelAddressModel' => false, 'WoocommercePpl\\Model\\Model\\LabelPrintModel' => false, 'WoocommercePpl\\Model\\Model\\CollectionAddressModel' => false, 'WoocommercePpl\\Model\\Model\\SenderAddressModel' => false, 'WoocommercePpl\\Model\\Model\\RecipientAddressModel' => false, 'WoocommercePpl\\Model\\Model\\BankAccountModel' => false, 'WoocommercePpl\\Model\\Model\\ShipmentCartModel' => false, 'WoocommercePpl\\Model\\Model\\ShipmentModel' => false, 'WoocommercePpl\\Model\\Model\\CurrencyModel' => false, 'WoocommercePpl\\Model\\Model\\ShipmentPhaseModel' => false, 'WoocommercePpl\\Model\\Model\\SyncPhasesModel' => false, 'WoocommercePpl\\Model\\Model\\UpdateSyncPhasesModel' => false, 'WoocommercePpl\\Model\\Model\\UpdateSyncPhasesModelPhasesItem' => false, 'WoocommercePpl\\Model\\Model\\CountryModel' => false, 'WoocommercePpl\\Model\\Model\\ShipmentMethodModel' => false, 'WoocommercePpl\\Model\\Model\\NewCollectionModel' => false, 'WoocommercePpl\\Model\\Model\\CollectionModel' => false, '\\Jane\\Component\\JsonSchemaRuntime\\Reference' => false);
    }
}