<?php

namespace WoocommercePpl\Model\Normalizer;

defined("WPINC") or die();

use WoocommercePplVendor\Jane\Component\JsonSchemaRuntime\Reference;
use WoocommercePpl\Model\Runtime\Normalizer\CheckArray;
use WoocommercePpl\Model\Runtime\Normalizer\ValidatorTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Exception\InvalidArgumentException;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerAwareInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerAwareTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\DenormalizerInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerAwareInterface;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerAwareTrait;
use WoocommercePplVendor\Symfony\Component\Serializer\Normalizer\NormalizerInterface;
class ParcelAddressModelNormalizer implements DenormalizerInterface, NormalizerInterface, DenormalizerAwareInterface, NormalizerAwareInterface
{
    use DenormalizerAwareTrait;
    use NormalizerAwareTrait;
    use CheckArray;
    use ValidatorTrait;
    public function supportsDenormalization($data, $type, $format = null, array $context = array()) : bool
    {
        return $type === 'WoocommercePpl\\Model\\Model\\ParcelAddressModel';
    }
    public function supportsNormalization($data, $format = null, array $context = array()) : bool
    {
        return is_object($data) && get_class($data) === 'WoocommercePpl\\Model\\Model\\ParcelAddressModel';
    }
    /**
     * @return mixed
     */
    public function denormalize($data, $class, $format = null, array $context = array())
    {
        if (isset($data['$ref'])) {
            return new Reference($data['$ref'], $context['document-origin']);
        }
        if (isset($data['$recursiveRef'])) {
            return new Reference($data['$recursiveRef'], $context['document-origin']);
        }
        $object = new \WoocommercePpl\Model\Model\ParcelAddressModel();
        if (\array_key_exists('id', $data) && \is_int($data['id'])) {
            $data['id'] = (double) $data['id'];
        }
        if (\array_key_exists('lat', $data) && \is_int($data['lat'])) {
            $data['lat'] = (double) $data['lat'];
        }
        if (\array_key_exists('lng', $data) && \is_int($data['lng'])) {
            $data['lng'] = (double) $data['lng'];
        }
        if (null === $data || false === \is_array($data)) {
            return $object;
        }
        if (\array_key_exists('id', $data) && $data['id'] !== null) {
            $object->setId($data['id']);
            unset($data['id']);
        }
        elseif (\array_key_exists('id', $data) && $data['id'] === null) {
            $object->setId(null);
        }
        if (\array_key_exists('code', $data) && $data['code'] !== null) {
            $object->setCode($data['code']);
            unset($data['code']);
        }
        elseif (\array_key_exists('code', $data) && $data['code'] === null) {
            $object->setCode(null);
        }
        if (\array_key_exists('name', $data) && $data['name'] !== null) {
            $object->setName($data['name']);
            unset($data['name']);
        }
        elseif (\array_key_exists('name', $data) && $data['name'] === null) {
            $object->setName(null);
        }
        if (\array_key_exists('name2', $data) && $data['name2'] !== null) {
            $object->setName2($data['name2']);
            unset($data['name2']);
        }
        elseif (\array_key_exists('name2', $data) && $data['name2'] === null) {
            $object->setName2(null);
        }
        if (\array_key_exists('street', $data) && $data['street'] !== null) {
            $object->setStreet($data['street']);
            unset($data['street']);
        }
        elseif (\array_key_exists('street', $data) && $data['street'] === null) {
            $object->setStreet(null);
        }
        if (\array_key_exists('city', $data) && $data['city'] !== null) {
            $object->setCity($data['city']);
            unset($data['city']);
        }
        elseif (\array_key_exists('city', $data) && $data['city'] === null) {
            $object->setCity(null);
        }
        if (\array_key_exists('zip', $data) && $data['zip'] !== null) {
            $object->setZip($data['zip']);
            unset($data['zip']);
        }
        elseif (\array_key_exists('zip', $data) && $data['zip'] === null) {
            $object->setZip(null);
        }
        if (\array_key_exists('country', $data) && $data['country'] !== null) {
            $object->setCountry($data['country']);
            unset($data['country']);
        }
        elseif (\array_key_exists('country', $data) && $data['country'] === null) {
            $object->setCountry(null);
        }
        if (\array_key_exists('remoteId', $data) && $data['remoteId'] !== null) {
            $object->setRemoteId($data['remoteId']);
            unset($data['remoteId']);
        }
        elseif (\array_key_exists('remoteId', $data) && $data['remoteId'] === null) {
            $object->setRemoteId(null);
        }
        if (\array_key_exists('type', $data) && $data['type'] !== null) {
            $object->setType($data['type']);
            unset($data['type']);
        }
        elseif (\array_key_exists('type', $data) && $data['type'] === null) {
            $object->setType(null);
        }
        if (\array_key_exists('lat', $data) && $data['lat'] !== null) {
            $object->setLat($data['lat']);
            unset($data['lat']);
        }
        elseif (\array_key_exists('lat', $data) && $data['lat'] === null) {
            $object->setLat(null);
        }
        if (\array_key_exists('lng', $data) && $data['lng'] !== null) {
            $object->setLng($data['lng']);
            unset($data['lng']);
        }
        elseif (\array_key_exists('lng', $data) && $data['lng'] === null) {
            $object->setLng(null);
        }
        foreach ($data as $key => $value) {
            if (preg_match('/.*/', (string) $key)) {
                $object[$key] = $value;
            }
        }
        return $object;
    }
    /**
     * @return array|string|int|float|bool|\ArrayObject|null
     */
    public function normalize($object, $format = null, array $context = array())
    {
        $data = array();
        if ($object->isInitialized('id') && null !== $object->getId()) {
            $data['id'] = $object->getId();
        }
        if ($object->isInitialized('code') && null !== $object->getCode()) {
            $data['code'] = $object->getCode();
        }
        if ($object->isInitialized('name') && null !== $object->getName()) {
            $data['name'] = $object->getName();
        }
        if ($object->isInitialized('name2') && null !== $object->getName2()) {
            $data['name2'] = $object->getName2();
        }
        if ($object->isInitialized('street') && null !== $object->getStreet()) {
            $data['street'] = $object->getStreet();
        }
        if ($object->isInitialized('city') && null !== $object->getCity()) {
            $data['city'] = $object->getCity();
        }
        if ($object->isInitialized('zip') && null !== $object->getZip()) {
            $data['zip'] = $object->getZip();
        }
        if ($object->isInitialized('country') && null !== $object->getCountry()) {
            $data['country'] = $object->getCountry();
        }
        if ($object->isInitialized('remoteId') && null !== $object->getRemoteId()) {
            $data['remoteId'] = $object->getRemoteId();
        }
        if ($object->isInitialized('type') && null !== $object->getType()) {
            $data['type'] = $object->getType();
        }
        if ($object->isInitialized('lat') && null !== $object->getLat()) {
            $data['lat'] = $object->getLat();
        }
        if ($object->isInitialized('lng') && null !== $object->getLng()) {
            $data['lng'] = $object->getLng();
        }
        foreach ($object as $key => $value) {
            if (preg_match('/.*/', (string) $key)) {
                $data[$key] = $value;
            }
        }
        return $data;
    }
    public function getSupportedTypes(?string $format = null) : array
    {
        return array('WoocommercePpl\\Model\\Model\\ParcelAddressModel' => false);
    }
}