<?php
namespace WoocommercePpl;

defined("WPINC") or die();

use WoocommercePpl\Model\Normalizer\CategoryModelNormalizer;
use WoocommercePpl\Model\Normalizer\CollectionAddressModelNormalizer;
use WoocommercePpl\Model\Normalizer\ProductModelNormalizer;
use WoocommercePpl\Model\Normalizer\ShipmentCartModelNormalizer;
use WoocommercePpl\Model\Normalizer\ShipmentPhaseModelNormalizer;
use WoocommercePpl\Model\Normalizer\SyncPhasesModelNormalizer;
use WoocommercePpl\Model\Normalizer\UpdateSyncPhasesModelNormalizer;
use WoocommercePpl\Model\Normalizer\UpdateSyncPhasesModelPhasesItemNormalizer;
use WoocommercePpl\Model\Normalizer\WhisperAddressModelNormalizer;
use WoocommercePpl\Model\Normalizer\WhisperSettingModelNormalizer;
use WoocommercePpl\ModelNormalizer\AddressModelDenormalizer;
use WoocommercePpl\ModelNormalizer\BankModelDenormalizer;
use WoocommercePpl\ModelNormalizer\CategoryModelDenormalizer;
use WoocommercePpl\ModelNormalizer\OrderAddressDataDenormalizer;
use WoocommercePpl\ModelNormalizer\PackageModelDernomalizer;
use WoocommercePpl\ModelNormalizer\ParcelDataModelDenormalizer;
use WoocommercePpl\ModelNormalizer\ProductModelDenormalizer;
use WoocommercePpl\ModelNormalizer\ShipmentCartModelDernomalizer;
use WoocommercePpl\ModelNormalizer\ShipmentDataDenormalizer;
use WoocommercePpl\Model\Normalizer\BankAccountModelNormalizer;
use WoocommercePpl\Model\Normalizer\CollectionModelNormalizer;
use WoocommercePpl\Model\Normalizer\CreateShipmentLabelBatchModelNormalizer;
use WoocommercePpl\Model\Normalizer\LabelPrintModelNormalizer;
use WoocommercePpl\Model\Normalizer\MyApi2Normalizer;
use WoocommercePpl\Model\Normalizer\NewCollectionModelNormalizer;
use WoocommercePpl\Model\Normalizer\PackageModelNormalizer;
use WoocommercePpl\Model\Normalizer\ParcelAddressModelNormalizer;
use WoocommercePpl\Model\Normalizer\ParcelDataModelGpsNormalizer;
use WoocommercePpl\Model\Normalizer\ParcelDataModelNormalizer;
use WoocommercePpl\ModelNormalizer\CollectionDataDenormalizer;
use WoocommercePpl\Model\Normalizer\PrepareShipmentBatchItemModelNormalizer;
use WoocommercePpl\Model\Normalizer\PrepareShipmentBatchModelNormalizer;
use WoocommercePpl\Model\Normalizer\PrepareShipmentBatchReturnModelNormalizer;
use WoocommercePpl\Model\Normalizer\RecipientAddressModelNormalizer;
use WoocommercePpl\Model\Normalizer\RefreshShipmentBatchReturnModelNormalizer;
use WoocommercePpl\Model\Normalizer\SenderAddressModelNormalizer;
use WoocommercePpl\Model\Normalizer\ShipmentLabelRefreshBatchModelNormalizer;
use WoocommercePpl\Model\Normalizer\ShipmentModelNormalizer;
use WoocommercePpl\Model\Normalizer\UpdateShipmentModelNormalizer;
use WoocommercePpl\Model\Normalizer\UpdateShipmentParcelModelNormalizer;




class Serializer extends \WoocommercePplVendor\Symfony\Component\Serializer\Serializer {
    public function __construct(array $normalizers = [], array $encoders = [])
    {
        parent::__construct([
            new ShipmentDataDenormalizer(),
            new CollectionDataDenormalizer(),
            new OrderAddressDataDenormalizer(),
            new AddressModelDenormalizer(),
            new BankModelDenormalizer(),
            new PackageModelDernomalizer(),
            new ShipmentDataDenormalizer(),
            new ParcelDataModelDenormalizer(),
            new ProductModelDenormalizer(),
            new ShipmentCartModelDernomalizer(),
            new CategoryModelDenormalizer(),

            // vygenerovano
            new ParcelDataModelNormalizer(),
            new ParcelDataModelGpsNormalizer(),
            new CollectionModelNormalizer(),
            new ShipmentModelNormalizer(),

            new NewCollectionModelNormalizer(),
            new RecipientAddressModelNormalizer(),
            new SenderAddressModelNormalizer(),
            new MyApi2Normalizer(),
            new SenderAddressModelNormalizer(),
            new BankAccountModelNormalizer(),
            new UpdateShipmentModelNormalizer(),
            new PackageModelNormalizer(),
            new ParcelAddressModelNormalizer(),
            new UpdateShipmentParcelModelNormalizer(),
            new LabelPrintModelNormalizer(),
            new PrepareShipmentBatchItemModelNormalizer(),
            new PrepareShipmentBatchModelNormalizer(),
            new CreateShipmentLabelBatchModelNormalizer(),
            new PrepareShipmentBatchReturnModelNormalizer(),
            new CreateShipmentLabelBatchModelNormalizer(),
            new RefreshShipmentBatchReturnModelNormalizer(),
            new ShipmentLabelRefreshBatchModelNormalizer(),
            new ProductModelNormalizer(),
            new ShipmentCartModelNormalizer(),
            new ShipmentPhaseModelNormalizer(),
            new UpdateSyncPhasesModelNormalizer(),
            new SyncPhasesModelNormalizer(),
            new UpdateSyncPhasesModelPhasesItemNormalizer(),
            new WhisperSettingModelNormalizer(),
            new WhisperAddressModelNormalizer(),
            new CollectionAddressModelNormalizer(),
            new CategoryModelNormalizer()


        ], $encoders);
    }

    protected static $instance;

    public static function getInstance() {
        return self::$instance ?: (self::$instance = new self());
    }
}