<?php

use WoocommercePpl\Model\Model\LabelPrintModel;

defined("WPINC") or die();
?>
<div id="ppl-order-panel-shipment-div-<?php echo $order->get_id()?>-overlay">
<?php
if ($shipments) {
/**
 * @var  \WoocommercePpl\Model\Model\ShipmentModel[] $shipments
 * @var \WC_Order $order
 */

foreach ($shipments as $key => $shipment):
    if ($shipment->isInitialized("id"))
        $shipmentId = $shipment->getId();
    else
        $shipmentId = 0;
    $addId = $order->get_id() . "_" . time();
    if ($shipmentId)
        $addId = $shipmentId;

    if ($shipment->isInitialized("recipient")) {
        /**
         * @var \WoocommercePpl\Model\Model\RecipientAddressModel $recipient
         */
        $recipient = $shipment->getRecipient();
        $recipient = join(', ', array_filter(array_map(function ($item) use ($recipient) {
            if ($item === "city") {
                $output = [];
                if ($recipient->isInitialized("zip"))
                    $output[] = $recipient->getZip();
                if ($recipient->isInitialized("city"))
                    $output[] = $recipient->getCity();
                return join(' ', $output);
            }
            if ($recipient->isInitialized($item))
                return $recipient->{"get{$item}"}();
            return null;
        }, ["name", "contact", "street", "city", "country", "phone"])));
    } else {
        $recipient = null;
    }
    $packages = "0";
    if ($shipment->isInitialized("packages")) {
        $packages = $shipment->getPackages();
        $packages = count($packages);
    }
?>
<table>
    <tr>
        <td style="text-align: right; padding-right: 1em">Služba:</td>
        <td style="vertical-align: middle">
            <?php if ($shipment->isInitialized("serviceCode")): ?>
            <?php echo $shipment->getServiceName() . " (" . $shipment->getServiceCode() . ")"; ?>&nbsp;<img src="<?php echo $jsImage[$key] ?>" height="20" style="position: relative; top: 5px"  />
            <?php else: ?>
            Nespecifikovaná služba
            <?php endif; ?>
        </td>

    </tr>
    <tr>
        <td style="text-align: right; padding-right: 1em">Adresa:</td>
        <td>
<?php if ($recipient): ?>
    <address>
<?php echo $recipient ?><br/>
    </address>
<?php endif; ?>
            <?php if ($shipment->isInitialized("hasParcel") && $shipment->getHasParcel()
                && $shipment->isInitialized("parcel") && $shipment->getParcel()) :
                $parcel = $shipment->getParcel();
                $parcelAddress = join(', ', array_filter(array_map(function ($item) use ($parcel) {
                    if ($item === "city") {
                        $output = [];
                        if ($parcel->isInitialized("zip"))
                            $output[] = $parcel->getZip();
                        if ($parcel->isInitialized("city"))
                            $output[] = $parcel->getCity();
                        return join(' ', $output);
                    }
                    if ($parcel->isInitialized($item))
                        return $parcel->{"get{$item}"}();

                    return null;
                }, ["name", "name2", "street", "city", "country"])));

                ?>
                Zásilka(y) jsou určeny na <?php if (strtolower($parcel->getType()) == "parcelshop"):?> parcelshop <?php else: ?>parcelbox<?php endif; ?>:
                <address>
                    <?php echo $parcelAddress ?>
                </address>
            <?php endif; ?>
        </td>
    </tr>
    <?php if ($shipment->isInitialized("note") && $shipment->getNote()): ?>
    <tr>
       <td style="text-align: right; padding-right: 1em">Poznámka:</td><td><?php echo $shipment->getNote();?></td>
    </tr>
    <?php endif; ?>
        <?php if ($shipment->isInitialized("codValue") && $shipment->getCodValue()): ?>
    <tr>
        <td style="padding-right: 1em; text-align: right">
            Dobírka:
        </td>
        <td>
            <?php echo $shipment->getCodValue() ?><?php echo $shipment->isInitialized("codValueCurrency") ? $shipment->getCodValueCurrency() : "???"?>
        </td>
    </tr>
        <tr>
            <td style="padding-right: 1em; text-align: right" >Variabilní symbol:</td>
            <td><?php echo $shipment->isInitialized("codVariableNumber") ? $shipment->getCodVariableNumber() : "Bez variabilního čísla"; ?></td>
        </tr>
    <?php endif; ?>
    <?php if (!$shipment->getImportState() || $shipment->getImportState() === 'None' || $shipment->getImportState() === "Error"): ?>
    <tr>
        <td style="text-align: right; padding-right: 1em">Počet zásilek:</td>
        <td>
            <?php echo $packages ?>
            <button class="add-package"
                    data-orderId="<?php echo $order->get_id()?>"
                    <?php if ($shipment->isInitialized("id")): ?>data-shipmentId="<?php echo $shipment->getId() ?>" <?php endif; ?> ><span class="dashicons dashicons-plus"></span>Přidat balík</button>
            <?php if ($packages > 1): ?>
            <button class="remove-package"
                    data-orderId="<?php echo $order->get_id()?>"
                    <?php if ($shipment->isInitialized("id")): ?>data-shipmentId="<?php echo $shipment->getId() ?>" <?php endif; ?> ><span class="dashicons dashicons-minus"></span>Odebrat balík</button>
            <?php endif;?>
        </td>
    </tr>
    <?php endif; ?>
    <?php if ($jsShipmentsErrors[$key] && (!$shipment->getImportState() || $shipment->getImportState() === 'None' || $shipment->getImportState() === "Error") ): ?>
        <tr>
            <td style="text-align: right; padding-right: 1em">Chyby na zásilce</td>
            <td>
                <div class="notice notice-error inline">
                    <?php
                    foreach ($jsShipmentsErrors[$key] as  $key2=> $item) {
                        ?><p><?php echo join(",", $item); ?></p><?php
                    }
                    ?>
                </div>
            </td>
        </tr>
    <?php endif;?>
<?php if ($shipment->getImportErrors()): ?>
<tr>
    <td style="text-align: right; padding-right: 1em">Chyby při importu</td>
    <td>
    <div class="notice notice-error inline">
        <?php foreach ($shipment->getImportErrors() as $importError): ?>
            <p><?php echo $importError ?></p>
        <?php endforeach; ?>
        <?php
            foreach ($jsShipmentsErrors[$key] as  $key2=> $item) {
            ?><p><?php echo join(",", $item); ?></p><?php
            }
        ?>
    </div>
    </td>
</tr>
<?php endif; ?>
</table>

<?php if ($shipment->getImportState() === "Complete" || array_filter($shipment->getPackages(),function ($item){
   return $item->isInitialized("importError") && $item->getImportError();
})) :?>
<table>
    <?php if ($shipment->isInitialized("batchLabelGroup") && $shipment->getBatchLabelGroup()):?>
    <tr>
        <td>
            Všechny zásilky na objednávce
        </td>
        <td style="vertical-align: center">
            <a id="ppl_reference_<?php echo urlencode($shipment->getReferenceId()); ?>" class="button all-labels ppl-label-download" target="_blank" href="/index.php?ppl_download=<?php echo urlencode($shipment->getBatchLabelGroup())?>&ppl_reference=<?php echo urlencode($shipment->getReferenceId())?>&ppl_print=<?php echo urlencode($selectedPrint); ?>" >
                <span style="position: relative; top: 5px" class="dashicons dashicons-admin-page"></span>
            </a>
            <?php
                $printLabel = array_filter($availablePrinters, function (LabelPrintModel $item) use ($selectedPrint) {
                    return $item->getCode() === $selectedPrint;
                });
                if ($printLabel):
                    $printLabel = reset($printLabel);
?>
                    <span style="position: relative; top: 5px">
                        <?php echo $printLabel->getTitle() ?>
                    </span>
                    <a style="position: relative; top: 5px" class="ppl_available_print_setting" href="#" data-optionals='<?php echo json_encode(\WoocommercePpl\Serializer::getInstance()->normalize($availablePrinters)) ?>' data-value="<?php echo $selectedPrint ?>" >Změnit</a>
                <?php
                endif;
            ?>
        </td>
    </tr>
    <?php endif ?>
<?php foreach ($shipment->getPackages() as $packageKey => $package):
    $packageKey++;
    ?>
    <tr>
        <td>
            <?php if ($package->isInitialized("shipmentNumber") && $package->getShipmentNumber()) : ?>
            <a href="https://www.ppl.cz/vyhledat-zasilku?shipmentId=<?php echo  $package->getShipmentNumber() ?>"><?php echo $package->getShipmentNumber()?></a>
            <?php endif; ?>
            <?php if ($package->isInitialized("referenceId") && $package->getReferenceId()) : ?>
            <?php echo "(ref: " . $package->getReferenceId() . ")" ?>
            <?php endif; ?>
        </td>
        <td style="vertical-align: middle;  line-height: 2.5em">
            <?php if ($package->isInitialized("labelId") && $package->getLabelId()):?>
                <?php if ($package->getPhase() === "None" || $package->getPhase() === "Order"): ?>
                <a id="ppl-order-panel-anchor-href-<?php echo $addId ?>"  target="_blank" href="/index.php?ppl_download=<?php echo $package->getId()?>&ppl_print=<?php echo urlencode($selectedPrint); ?>" class="button ppl-label-download">
                    <span style="position: relative; top: 5px" class="dashicons dashicons-printer"></span>
                </a>
                <button class="button cancel-package"
                        data-orderId="<?php echo $order->get_id()?>"
                        data-shipmentId="<?php echo $shipment->getId() ?>"
                        data-packageId="<?php echo $package->getId() ?>">Zrušit tuto zásilku</button>
                <?php endif; ?>
            <?php endif; ?>
            <?php if ($package->isInitialized("phase") && $package->getPhase() === "Canceled"): ?>
            Zrušeno
            <?php else: ?>
            <?php echo $package->getPhaseLabel(); ?>
            <?php endif; ?></td>
        <td style="color: red"><?php echo $package->getImportError() ?></td>
        <td style="color: red"><?php echo $package->getImportErrorCode() ?></td>
    </tr>
<?php endforeach; ?>
</table>
<?php endif; ?>
<hr/>
<?php if (!$shipment->getImportState() || $shipment->getImportState() === 'None' || $shipment->getImportState() === "Error"): ?>
<button class="button detail-shipment"
        data-orderId="<?php echo $order->get_id()?>"
        <?php if ($shipment->isInitialized("id")): ?>data-shipment='<?php echo json_encode(\WoocommercePpl\Serializer::getInstance()->normalize($shipment)) ?>'<?php endif; ?> >Upravit zásilku</button>
<?php endif; ?>
<?php if (in_array($shipment->getImportState(), ["InProcess", "InProgress", "Accepted"])): ?>
    <button disabled
            class="button refresh-shipments-labels"
            data-orderId="<?php echo $order->get_id()?>"
            <?php if ($shipment->isInitialized("id")): ?>data-shipmentId="<?php echo $shipment->getId() ?>" <?php endif; ?>>Probíhá příprava etikety</button>
<?php elseif($shipment->getImportState() === "Complete"): ?>
    <button class="button refresh-shipments"
            type="button"
            data-orderId="<?php echo $order->get_id()?>"
            <?php if ($shipment->isInitialized("id")): ?>data-shipmentId="<?php echo $shipment->getId() ?>" <?php endif; ?>>Aktualizovat stav zásilky</button>
<?php elseif  ($jsShipmentsOk[$key] || $shipment->getImportState() === "Error"): ?>
<button class="button create-labels"
        type="button"
        data-orderId="<?php echo $order->get_id()?>"
        <?php if ($shipment->isInitialized("id")): ?>data-shipmentId="<?php echo $shipment->getId() ?>"  <?php endif; ?> data-shipment='<?php echo json_encode(\WoocommercePpl\Serializer::getInstance()->normalize($shipment)) ?>'>Tisk etiket</button>
<?php endif; ?>
    <?php
    if ($shipment->getId() && in_array($shipment->getImportState(), [
            "Error",
            "None",
            ""
        ], true)) {
        ?>
        <button class="button remove-shipment"
                type="button"
                data-orderId="<?php echo $order->get_id()?>"
                data-shipmentId="<?php echo $shipment->getId() ?>">Odstranit</button>
    <?php } ?>
    <?php if ($key !=  array_key_last($shipments)) :?>
    <hr style="margin-left: -12px; margin-right:-12px"/>
    <?php endif; ?>
    <?php
endforeach;
?>
    <hr style="margin-left: -12px; margin-right:-12px"/>
    Chcete vytvořit další dopravu v rámci PPL?
    <br/><button data-orderId="<?php echo $order->get_id()?>" class="button detail-shipment">Vytvořit</button>
<?php
} else {
?>
    Pro tuto objednávku nebyla vybrána doprava pomoci PPL.<br/><button data-orderId="<?php echo $order->get_id()?>" class="button detail-shipment">Chcete dopravu vytvořit?</button>
<?php
}
?>
    <script type="text/javascript">
        (function() {
            window.pplPlugin = window.pplPlugin || [];
            window.pplPlugin.push(["pplOrderPage", "ppl-order-panel-shipment-div-<?php echo $order->get_id()?>-overlay", { orderId: <?php echo $order->get_id()?> }])
        })()
    </script>
</div>