<?php
defined("WPINC") or die();
?>
<?php
$shipmentPhase = [
    "Order" => "Objednáno",
    "InTransport" => "V&nbsp;přepravě",
    "Delivering" =>"Na&nbsp;cestě",
    "PickupPoint" => "Na&nbsp;výdejním&nbsp;místě",
    "Delivered" => "Doručeno",
    "Returning" => "Zpět&nbsp;k&nbsp;odesílateli",
    "BackToSender" => "Vráceno"
];

?>
<div id="ppl-order-panel-shipment-div-<?php echo $order->get_id()?>-overlay">
    <img src="<?php echo ppl_asset_icon("ppldhl_4084x598.png"); ?>" height="20"><br/>
    <?php
    /**
     * @var  \WoocommercePpl\Model\Model\ShipmentModel[] $shipments
     * @var \WC_Order $order
     */
    $pruchod = false;

    foreach ($shipments as $key => $shipment):
        $batchLabelGroup = null;
        if ($shipment->isInitialized("batchLabelGroup") && $shipment->getBatchLabelGroup())
        {
            $batchLabelGroup = $shipment->getBatchLabelGroup();
        }
?>
    <?php if ($shipment->getImportState() === "Complete") :?>
    <?php if ($batchLabelGroup):?>Hromadně <a target="_blank" href="/index.php?ppl_download=<?php echo urlencode($batchLabelGroup)?>" class="dashicons dashicons-admin-page"></a><br/><?php endif; ?>
    <?php foreach ($shipment->getPackages() as $package):?>
        <div style="white-space: nowrap;">
        <?php if ($package->getShipmentNumber()): ?><a href="https://www.ppl.cz/vyhledat-zasilku?shipmentId=<?php echo $package->getShipmentNumber()?>" target="_blank"><?php echo $package->getShipmentNumber() ?><?php endif; ?>&nbsp;
        <?php if ($package->getLabelId() && in_array($package->getPhase(), ["Order", "None"])):?>
            <a target="_blank" href="/index.php?ppl_download=<?php echo $package->getId()?>" class="dashicons dashicons-printer"></a>
        <?php endif; ?>
        <?php if ($package->isInitialized("phaseLabel")): ?>
        <?php echo @$shipmentPhase[$package->getPhase()] ?>
        <?php endif; ?>
        </div>
    <?php endforeach;?>
    <?php else : ?>
    <?php if (!$jsShipmentsOk[$key] || $shipment->getImportErrors() || $shipment->getImportState() === "Error") :?><span style="color: red" class="dashicons dashicons-dismiss"></span>Chyba na zásilce<?php endif; ?>
    <?php if (($shipment->getImportState() === "None")) : ?>
        <script type="text/javascript">
            if (!window.ppl_is_cb_select_all_set) {
                jQuery("#cb-select-all-1, #cb-select-all-1").off("click.ppl_table_column").on("click.ppl_table_column", function() {
                    setTimeout(function() {
                        if (!jQuery("input").toArray().some(function(item) {
                            item = jQuery(item);
                            if (item.is(":checked") && item.data("ppl-shipment-data-create-shipment")) {
                                return true;
                            }
                            return false;
                        })) {
                            jQuery("#ppl-create-shipments").hide();
                        } else {
                            jQuery("#ppl-create-shipments").show();
                        }
                    });
                })
                window.ppl_is_cb_select_all_set = true;
            }

            function show_create_labels (ev)
            {

                ev.preventDefault();
                const output = [];
                jQuery("input").toArray().some(function(item) {
                    item = jQuery(item);
                    if (item.is(":checked") && item.data("ppl-shipment-data-create-shipment")) {
                        debugger;
                        item.data("ppl-shipment-data-create-shipment").forEach(function(x) {
                            output.push({ shipment: x })
                        });
                    }
                })

                if (output.length) {
                    var unmount = null;

                    var pplPlugin = window.pplPlugin || [];
                    pplPlugin.push(["wpUpdateStyle", "ppl-create-shipments"]);
                    var div = jQuery("<div>").appendTo("body");
                    pplPlugin.push(["newLabels", div[0], {
                        shipments: output,
                        "returnFunc": function(data) {
                            unmount = data.unmount;
                        },
                        onFinish:function (){
                            unmount();
                        },
                        onRefresh: function(orderIds) {
                            wp.ajax.post({
                                action: "ppl_orders_table",
                                orderIds: orderIds
                            }).done(function(item) {

                                Object.keys(item.orders).forEach(function (key) {
                                    jQuery("#ppl-order-panel-shipment-div-" + key + "-overlay").replaceWith(item.orders[key]);
                                })
                            })
                        }
                    }])
                }
            }

            jQuery("#doaction2, #doaction").off("click.ppl-create-shipments").on("click.ppl-create-shipments", function(ev)
            {

                var value = jQuery("#bulk-action-selector-top").val();
                if (value === 'ppl_bulk_operation_create_labels') {
                    show_create_labels(ev);
                }
            });
            jQuery("#wc-orders-filter #ppl-create-shipments").off("click.ppl-create-shipments").on("click.ppl-create-shipments", show_create_labels);

            var oldData =  jQuery("input#cb-select-<?php echo $order->get_id(); ?>").data("ppl-shipment-data-create-shipment");
            if (!oldData)
                oldData = [];
            oldData.push(<?php echo json_encode($jsShipments[$key]) ?>);
            jQuery("input#cb-select-<?php echo $order->get_id(); ?>").data("ppl-shipment-data-create-shipment", oldData);
            jQuery("input#cb-select-<?php echo $order->get_id()?>").off("click.ppl_table_column").on("click.ppl_table_column", function() {

                if (jQuery(this).is(":checked"))
                {
                    jQuery("#ppl-create-shipments").show();
                } else {
                    if (!jQuery("input").toArray().some(function(item) {
                        item = jQuery(item);
                        if (item.is(":checked") &&  item.data("ppl-shipment-data-create-shipment")) {
                            return true;
                        }
                    })) {
                        jQuery("#ppl-create-shipments").hide();
                    } else  {
                        jQuery("#ppl-create-shipments").show();
                    }
                }
            })
        </script>
    <?php endif; ?>
    <?php endif; ?>
    <?php
    endforeach;
    ?>
</div>