<?php
defined("WPINC") or die();


return call_user_func(function() {

    if (!\WoocommercePpl\Admin\CPLOperation::PROD_VERSION) {
        // TODO odstranit simulaci
        $address = json_decode(<<< JSONC
    {
        "code": "PICK",
          "name": "PPL WA účet",
          "street": "Holická 170/47",
          "city": "Olomouc - Hodolany",
          "zip": "77900",
          "country": "CZ",
          "default": true
     }
JSONC, true);

        return $address;
    }

    $address = null;
    try {
        $address = get_transient(create_ppl_name("collection_address")) ?: null;
        if (!is_array($address))
            $address = null;
    }
    catch (Exception $ex)
    {

    }

    try {
        if (!$address || defined("WOOCOMMERCE_PPL_REFRESH")) {


            $cpl = new \WoocommercePpl\Admin\CPLOperation();
            $collectionAddresses = $cpl->getCollectionAddresses();

            foreach ($collectionAddresses as $key => $value) {
                $collectionAddresses[$key] = \WoocommercePpl\Serializer::getInstance()->denormalize($value, \WoocommercePpl\Model\Model\CollectionAddressModel::class);
            }

            if ($collectionAddresses) {
                $collectionAddress = array_filter($collectionAddresses, function (\WoocommercePpl\Model\Model\CollectionAddressModel $model) {
                    return $model->getCode() === "PICK";
                });
                if ($collectionAddress) {
                    $address = reset($collectionAddress);
                    set_transient(create_ppl_name("collection_address"), \WoocommercePpl\Serializer::getInstance()->normalize($address));
                    return  \WoocommercePpl\Serializer::getInstance()->normalize($address);
                }
            }
        }
    }
    catch (\Exception $exception)
    {
        return null;
    }
    return $address;
});